
let textConfiguration = "123";

function modal_authenticationDisplay() {
  document.getElementById("modal_authentication").style.display = "block";
  document.getElementById("modal_authentication_pass").focus();
}

function initPage() {
  w3_open(); // Открываем левое меню

  var header = document.getElementById("mySidebar"); // Вешаем визуальные эффекты на левое меню
  var btns = header.getElementsByClassName("w3-bar-item");
  for (var i = 0; i < btns.length; i++) {
    btns[i].addEventListener("click", function () {
      var current = document.getElementsByClassName("active");
      current[0].className = current[0].className.replace(" active", "");
      this.className += " active";
    });
  }

  initPage_ONCHANGE(); // Обработчик КЛИКОВ по инпутам интерфеса
}

function initPage_ONCHANGE() {
  // Обработчик КЛИКОВ по инпутам интерфеса

  document.getElementById("file-upload").onchange = function (e) {
    // Открытие файла конфигурации
    var fr = new FileReader();
    fr.onloadend = function () {
      var xhr = new XMLHttpRequest();
      xhr.open("POST", vhost + CMD_FILE_READ + "&file=" + e.target.files[0].name.toLowerCase(), true);
      xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");

      xhr.onreadystatechange = function () {
        if (this.readyState != 4) return;
        data = JSON.parse(xhr.responseText);

        if (data.result !== "error") {
          if (data.result.toLowerCase() === "ok") {
            parseAppKey("update");
            readConfigServer();
            document.getElementById("buttonSaveDevice").classList.remove("w3-green");
            document.getElementById("buttonSaveDevice").classList.remove("w3-vibration");
            document.getElementById("buttonSaveDevice").classList.remove("w3-border-green");
            document.getElementById("buttonSaveDevice").classList.remove("w3-border-white");
            document.getElementById("buttonSaveDevice").classList += " w3-border-green w3-green w3-vibration";
            document.getElementById("buttonSaveDevice").style.display = 'block'
            document.getElementById("buttonSaveDevice").disabled = ''
            document.getElementById("file-upload").value = null
          }
          else if (data.result.toLowerCase() === "password") {
            document.getElementById("modal_new_config_mode").style.display = "none";
            modal_authenticationDisplay();
          }
        } else if (data.result === "error") {
          // document.getElementById('modal_new_config_mode').style.display = 'none';
          modal_authenticationDisplay();
          alertbox.show("Ошибка чтения файла конфигурации");
        }
      };
      xhr.send(fr.result);
    };
    fr.readAsBinaryString(e.target.files[0]);

  };
  function loadZipFile(files) {
    isSecondCore = deviceSecondCore.includes(DEVICEMODEL) ? true : false
     
    $.modal("#modal_loader");
    findKeyforDeviceUpdate()
    arrayZfile = []
    arrayZfileSecCore = []
    //let files = e.target.files;
    $.hide("#satus_new_version_custom");
    $.hide("#satus_new_version_secondcore");
    $.hide("#error_format");
    $.hide("#empty_po");
    $.hide("#empty_po_sec");

    if (files[0] && (files[0].name.toLowerCase().includes('.zip') || files[0].name.toLowerCase().includes('.efp'))) {
      $.hide("#button_main_core_burn");
      $.hide("#button_sec_core_burn");
      // Открытие zip-файла конфигурации
      for (let i = 0; i < files.length; i++) {

        handleFile(files[i], isSecondCore);
      }
    } else if (files[0] && files[0].name.toLowerCase().includes('.bin')) {
      
      // Открытие файла конфигурации
      var fr = new FileReader();
      fr.onloadend = function () {
        fileXCPU = fr.result;
      };
      //  fr.readAsBinaryString(files[0]);
      fr.readAsArrayBuffer(files[0]);
      $.show("#satus_new_version_custom");
      $.hide("#button_main_ofline");

      document.getElementById("number_new_ver_custom").innerHTML = `${findVersionNumber(files[0].name)}`
      $.show("#button_main_core_burn");
      // if (isSecondCore) $.show("#button_sec_core_burn");
      if (stateDevice === "0") {
        document.getElementById('button_main_core_burn').disabled = true
        document.getElementById('button_sec_core_burn').disabled = true
      } else {
        document.getElementById('button_main_core_burn').disabled = false
        // document.getElementById('button_sec_core_burn').disabled = false
      }
    } else {
      $.hide("#satus_new_version_custom");
      $.hide("#satus_new_version_secondcore");
      $.show("#error_format");

    }
    document.getElementById("file-upload-main-core").value = null
    $.hide("#modal_loader");
  }


  document.getElementById("file-upload-main-core").onchange = function (e) {
    let files = e.target.files;
    loadZipFile(files)
  };






  function findVersionNumber(text) {

    const regex = /((\d+[a-zA-Z]?)_(\d+[a-zA-Z]?).bin)/
    const regGroup = text.toLowerCase().match(regex);
    updateFileName = regGroup ? regGroup[1] : text

    if (regGroup) {
      let versionName = regGroup[3];
      versionName = versionName.charAt(0) + "." + versionName.charAt(1) + versionName.charAt(2)
      return versionName
    }
    return text


  }

  async function findZip_crc_ver(file, core) {
    //разбор последней доступной версии ПО из update.txt из zip-файла
    const zip = await JSZip.loadAsync(file);
    let newVer = ''

    for (let zobj of Object.values(zip.files)) {
      if (core === 'main') {
        folder = !zobj.name.includes('/1/')
      } else {
        folder = zobj.name.includes('/1/')
      }
      function nameVerification(name, path) {
        return path === name.slice(0, path.length)
      }

      if (zobj.name.includes('.txt') && nameVerification(zobj.name, folderPath) && folder) {
        const zblob = await zobj.async("blob");
        const zfile = new File([zblob], zobj.name, {
          lastModified: zobj.date.getTime(),
          type: 'application/zip'
        });
        text = await zfile.text()
        const regex = /((\d+[a-zA-Z]?)_(\d+[a-zA-Z]?).bin)\s([a-fA-F0-9]+)/
        const regGroup = text.match(regex);
        model = regGroup[2];
        newVer = regGroup[3];
        if (core === 'main') {
          crc = regGroup[4];
        } else {
          crc_SecCore = regGroup[4];
        }

      }
    }
    return newVer;
  }
  async function handleFile(file, secondCore = false) {


    const zip = await JSZip.loadAsync(file);

    let newVersionUpdate = await findZip_crc_ver(file, 'main')
    const model = DEVICEMODEL.replace(/[^0-9]/g, "").slice(0, 4)
    for (let zobj of Object.values(zip.files)) {
      const name = zobj.name.toLowerCase()
      if (name.includes(folderPath) && name.includes(model) && name.includes('.bin') && !name.includes('/1/')) {
        let zipVer = name.split('/')
        const regGroup = zipVer[zipVer.length - 1].match(/((\d+[a-zA-Z]?)_(\d+[a-zA-Z]?).bin)/);
        zipVer = regGroup[3];
        if (verElestaToInt(zipVer) !== verElestaToInt(currentCoreVersion)) {

          const zblob = await zobj.async("blob");
          const zfile = new File([zblob], zobj.name, {
            lastModified: zobj.date.getTime(),
            type: 'application/zip'
          });

          arrayZfile.push(zfile)
        }

      }
      if (name.includes(folderPath) && name.includes('.exe') && name.includes('/exe/')) {

        const zblob = await zobj.async("blob");
        const zfile = new File([zblob], zobj.name, {
          lastModified: zobj.date.getTime(),
          type: 'application/zip'
        });
        elesta4Exe = zfile


      }
    }
    document.getElementById("block_upload").style.display = ''
    document.getElementById("text_updateSoft_versions").innerHTML = ''
    if (arrayZfile.length === 0) {
      $.show("#empty_po");
      arrayZfile = []
    } else {
      $.show("#button_main_ofline");
      $.show("#satus_new_version_custom");

      let str = ``
      str += '<select onchange="swapSectionVersionPO(this)" id="sect_S_42' + '" name="' + 'updatePO' + '" >';

      for (let i = arrayZfile.length - 1; i >= 0; i--) {
        str += `<option value="${i}" `;
        if (arrayZfile[i].name.includes(newVersionUpdate)) {
          param_zip_number = i
          str += " selected ";
        }
        str += ">";
        str += findVersionNumber(arrayZfile[i].name) + "</option>";
      }
      str += "</select>";
      document.getElementById("number_new_ver_custom").innerHTML = str

    }
    if (secondCore) {
      //Сатурн - 28xx Вспомогательное ядро
      let newVersionUpdate = await findZip_crc_ver(file, 'second')
      for (let zobj of Object.values(zip.files)) {
        const name = zobj.name.toLowerCase()
        if (name.includes(folderPath) && name.includes(model) && name.includes('.bin') && name.includes('/1/')) {
          let zipVer = name.split('/')
          const regGroup = zipVer[zipVer.length - 1].match(/((\d+[a-zA-Z]?)_(\d+[a-zA-Z]?).bin)/);
          zipVer = regGroup[3];
          if (verElestaToInt(zipVer) !== verElestaToInt(currentSecondCoreVersion)) {

            const zblob = await zobj.async("blob");
            const zfile = new File([zblob], zobj.name, {
              lastModified: zobj.date.getTime(),
              type: 'application/zip'
            });
            arrayZfileSecCore.push(zfile)
          }
        }
      }
      if (arrayZfileSecCore.length === 0) {
        if (stateDevice !== "10") {
          $.show("#empty_po_sec");
        }
        arrayZfileSecCore = []
      } else {
        if (stateDevice !== "10") {
          $.show("#button_main_ofline_secondcore");
          $.show("#satus_new_version_secondcore");
        } else {
          $.hide("#button_main_ofline_secondcore");
          $.hide("#satus_new_version_secondcore");
        }
        if (stateDevice === "0") {
          document.getElementById('button_main_ofline_secondcore').disabled = true
        } else {

          document.getElementById('button_main_ofline_secondcore').disabled = false
        }
        let str2 = ``
        str2 += '<select onchange="swapSectionVersionPO(this)" id="sect_S_42' + '" name="' + 'updatePO' + '" >';

        for (let i = arrayZfileSecCore.length - 1; i >= 0; i--) {
          str2 += `<option value="${i}" `;
          if (arrayZfileSecCore[i].name.includes(newVersionUpdate)) {
            param_zip_number = i
            str2 += " selected ";
          }
          str2 += ">";
          str2 += findVersionNumber(arrayZfileSecCore[i].name) + "</option>";
        }
        str2 += "</select>";
        document.getElementById("number_new_ver_secondcore").innerHTML = str2
      }


    }

  }



  document.getElementById("file-upload-second-core").onchange = function (e) {
    // Открытие файла конфигурации
    var fr = new FileReader();
    fr.onloadend = function () {
      fileMODEM = fr.result;
      $.show("#button_second_core_burn");
    };
    fr.readAsBinaryString(e.target.files[0]);
  };

  let btnAutoTune = document.getElementById("autoTuneBtn");
  btnAutoTune.onclick = function () {
    AutoTuner.prototype.run();
  };

  if (TUNER_DEVICE_ID == "-7") {
    $.show("#buttonCmdUpdateRKPS");
  } else {
    $.hide("#buttonCmdUpdateRKPS");
  }


  $.hide("#controlSpeedRs485");
}
function stopSearchRadio() {
  document.getElementById('modal_error_radio_detected').style.display = 'none'
  initSearchRadio = false// Выключили режим поиска РК датчика
  spiner_stop();
}
function w3_open() {
  document.getElementById("container_main").style.marginLeft = "20%";
  document.getElementById("mySidebar").style.width = "20%";
  document.getElementById("mySidebar").style.display = "block";
  document.getElementById("close_btn").style.display = "block"; //показываем кнопку закрыть
  document.getElementById("open_btn").style.display = "none"; // прячем кнопку открыть
  if (document.getElementById("myHeader")) {
    document.getElementById("myHeader").style.minWidth = "78%;"
    document.getElementById("myHeader").style.width = "";
  }
}


function w3_close() {
  document.getElementById("container_main").style.marginLeft = "0%";
  document.getElementById("mySidebar").style.display = "none";
  document.getElementById("close_btn").style.display = "none"; //прячем кнопку закрыть
  document.getElementById("open_btn").style.display = "block"; // показываем кнопку открыть
  document.getElementById("myHeader").style.width = "100%";
}

function openTabs(evt, name) {
  var i, x, tablinks;
  x = document.getElementsByClassName("tab_content");
  for (i = 0; i < x.length; i++) {
    x[i].style.display = "none";
  }
  tablinks = document.getElementsByClassName("tablink");
  for (i = 0; i < x.length; i++) {
    tablinks[i].className = tablinks[i].className.replace(" active", "");
  }
  document.getElementById(name).style.display = "block";
  evt.currentTarget.className += " active";
  ACTIVE_TABS = name;
  if (name === "tab_r_device" && virtualRadio.length > 10) {
    $.show("#arrowTop");
    $.show("#arrowDown");
  } else {
    $.hide("#arrowTop");
    $.hide("#arrowDown");
  }
}
window.onbeforeunload = function () {
  if (KEYFORSAVE.length > 0) {
    return false;
  }
};


window.addEventListener('unload', () => {
  fetch(vhost + CMD_SEND_DEVICE + 'ec', {
    method: 'get',
    headers: {
      'Content-Type': 'application/json',
    },
    keepalive: true, // this is important!
  });
});


function closeErrorModalDeviceKeys() {
  document.getElementById("modal_error_device_key").style.display = "none";
  document.getElementById('modal_conf_toDev').style.display = "none";
  document.querySelector('.error_device_key_text').innerHTML = "";
}


function appendInteface() {
  //TUNER_DEVICE_ID = id;
  let str = `
  <div class="w3-top">
        <div class="w3-bar">
          <a style="display:none" title="скрыть меню" onclick="w3_close()" href="#" class="w3-bar-item w3-button" id="close_btn">☰</a>
          <a style="display:none" title="показать меню" onclick="w3_open()" href="#" class="w3-bar-item w3-button" id="open_btn">☰</a>
        
          <button id="buttonMenu" title="Меню конфигуратора" class="w3-bar-item w3-blue w3-button" onclick="$.modal('#modal_new_config_mode')">
           Меню
          </button>
          <button
            style="display:none"
            onclick="document.getElementById('modal_connect').style.display='block'"
            class="btnConnect w3-bar-item w3-button w3-green"
          >
            Подключить
          </button>
          <button style="display:none" onclick="newConfigurationModal()" class="w3-bar-item w3-button w3-blue">Новая конфигурация</button>
          <!--
            button onclick="demoMode()" class="btnConnect w3-bar-item w3-button w3-blue">
            Демо</button
          -->
          <button
            title="Отключиться от прибора"
            onclick="checkDisconnectDevice()"
            style="display:none"
            class="btnDisconnect w3-bar-item w3-btn w3-red w3-border-red"
          >
            Отключить
          </button>
          <button
            title="Выполнить авторизацию прибора"
            onclick="modal_authenticationDisplay()"
            class="authenticationBtn w3-bar-item w3-button w3-amber"
            style="display:none"
          >
            Авторизация
          </button>
          <button
            title="Записать конфигурацию в прибор"
            id="buttonSaveDevice"
            onclick="document.getElementById('modal_conf_toDev').style.display='block'"
            class="saturn_28 w3-bar-item w3-btn w3-border-white"
            style="display:none"
          >
            Записать в прибор
          </button>
          <button id="burnToDevice" title="Записать конфигурацию на USB устройство" class="w3-bar-item w3-green w3-button saturn_28" style="display:none" onclick="getUsbDevice()">
            Записать в прибор 
          </button>
          <button id="buttonLoadInDevice" title="Загрузить конфигурацию из прибора" class="w3-bar-item w3-button saturn_28" style="display:none" onclick="modal_getDevice_conf()">
            Загрузить из прибора
          </button>
          <button id='btn_reset_device'
            title="Выполнить перезапуск прибора"
            onclick="document.getElementById('modal_reset').style.display='block'"
            class="w3-bar-item w3-button saturn_28"
            style="display:none"
          >
            <div id='btn_reset_device_icon' style='float:left; margin-right: 5px;'>↻ </div> Перезапуск 
          </button>
          <button onclick="exitTuner()" id="btn_exit" style="float: right; display:" class="w3-bar-item w3-btn w3-red w3-border w3-small w3-border-red">X</button>
          <!-- Дропдаун Конфигурация -->
          <div class="w3-dropdown-hover w3-mobile saturn_28" style="display:none">
            <button class="w3-button">
            <span>&#8595;</span>  
            <span style="vertical-align: middle">Конфигурация</span></button>
            <div class="w3-dropdown-content w3-bar-block w3-blue">
              <label  title="Открыть конфигурационный файл" for="file-upload" class="custom-file-upload w3-bar-item w3-button">
                <i class="fa fa-cloud-upload"></i>Открыть
              </label>
              <input id="file-upload" type="file" />

              <button title="Сохранить текущую конфигурацию в файл" onclick="configIniSave()" class="w3-bar-item w3-button">Сохранить как</button>
              <!-- button class="w3-bar-item w3-button">Сбросить</button -->
              <button title="Сбросить настройки прибора на заводские" onclick="modalConfigToDefault()" class="w3-bar-item w3-button">На заводские</button>
              <button style="display:" title="Распечатать конфигурацию" onclick="CallPrint('print-content')" class="w3-bar-item w3-button" >Печать</button>
            </div>
          </div>
          

          <!-- Тестовая телеметрия -->
          <button onclick="testTelemetriya()" class="w3-bar-item w3-button" style="display:none">Тест_Телеметрии</button>
        </div>
      </div>

      <div class="w3-sidebar w3-bar-block w3-card w3-animate-opacity" style="display:none; margin-top:45px; z-index:0" id="mySidebar">
      <button disabled="" style="background:#333;cursor: inherit; opacity:1; color:#ffb03b" href="#" onclick="" class="tablink w3-bar-item w3-button w3-codespan w5_bar_alltabs" id="model_dev_p"></button>
        <a
          style="display:none"
          href="#"
          onclick="openTabs(event, 'tab_statusDevice')"
          class="startTuner w3-blue tab_statusDevice w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
          id="defaultClick"
        >
          Мониторинг<i class="face_arrow_right">></i></a
        >
        
        <a style="display:none" href="#" id="defaultClick_pk4" onclick="openTabs(event, 'tab_main_pk4')" class="tab_main_pk4 w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
        ><i class="face_arrow_right">></i>Общие</a>

        <a style="display:none" href="#" onclick="openTabs(event, 'tab_mode_pk4')" class="tab_mode_pk4 w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
        ><i class="face_arrow_right">></i>Режимы</a>

        <a style="display:none" href="#" onclick="openTabs(event, 'tab_indication_pk4')" class="tab_indication_pk4 w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
        ><i class="face_arrow_right">></i>Индикация</a>

        <a style="display:none" href="#" onclick="openTabs(event, 'tab_sensors_pk4')" class="tab_sensors_pk4 w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
        ><i class="face_arrow_right">></i>Шлейфы</a>

        <a style="display:none" href="#" onclick="openTabs(event, 'tab_rele_pk4')" class="tab_rele_pk4 w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
        ><i class="face_arrow_right">></i>Выходы управления</a>

        <a style="display:none" href="#" onclick="openTabs(event, 'tab_keys_pk4')" class="tab_keys_pk4 w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
        ><i class="face_arrow_right">></i>Коды пользователей</a>

        <a style="display:none" href="#" onclick="openTabs(event, 'tab_sms_pk4')" class="tab_sms_pk4 w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
        ><i class="face_arrow_right">></i>SMS</a>

        <a style="display:none" href="#" onclick="openTabs(event, 'tab_sms_k_pk4')" class="tab_sms_k_pk4 w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
        ><i class="face_arrow_right">></i>SMS-K</a>
        
        

        <a style="display:none" href="#" onclick="openTabs(event, 'tab_ip_udp_pk4')" class="tab_ip_udp_pk4 w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
        ><i class="face_arrow_right">></i>IP/UDP</a>
        
        <a style="display:none" href="#" onclick="openTabs(event, 'tab_gprs_pk4')" class="tab_gprs_pk4 w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
        ><i class="face_arrow_right">></i>GPRS</a>

        <a style="display:none" href="#" onclick="openTabs(event, 'tab_ethernet_pk4')" class="tab_ethernet_pk4 w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
        ><i class="face_arrow_right">></i>ETHERNET?</a>

        <a style="display:none" href="#" onclick="openTabs(event, 'tab_plugin_pk4')" class="tab_plugin_pk4 w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
        ><i class="face_arrow_right">></i>Расширения</a>
      

        <a
          id="secondClick"
          style="display:none"
          href="#"
          onclick="openTabs(event, 'tab_main')"
          class="tab_main w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
          ><i class="face_arrow_right">></i>Общие</a
        >
        <a style="display:none" href="#" onclick="openTabs(event, 'tab_mode')" class="tab_mode w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
          ><i class="face_arrow_right">></i>Режимы</a

        >
        <a style="display:none" href="#" onclick="openTabs(event, 'tab_indication')" class="tab_indication w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
          ><i class="face_arrow_right">></i>Индикация</a
        >
        <a
          style="display:none"
          href="#"
          onclick="openTabs(event, 'tab_sensors')"
          class="tab_sensors w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
          ><i class="face_arrow_right">></i>Шлейфы</a
        >        
        
        <a
        style="display:none"
        href="#"
        onclick="openTabs(event, 'tab_extender')"
        class="tab_extender w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
        ><i class="face_arrow_right">></i>Расширители</a
        >

        <a
        style="display:none"
        href="#"
        onclick="openTabs(event, 'tab_r_device')"
        class="tab_r_device w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
        ><i class="face_arrow_right">></i>Радиоканал</a
        >

        <a
        style="display:none"
        href="#"
        onclick="openTabs(event, 'tab_zone')"
        class="tab_zone w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
        ><i class="face_arrow_right">></i>Зоны</a
        >

        <a 
        style="display:none"
        href="#"
        onclick="openTabs(event, 'tab_sections')"
        class="tab_sections w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
        ><i class="face_arrow_right">></i>Разделы</a>       

        <a 
        style="display:none"
        href="#"
        onclick="openTabs(event, 'tab_exe')"
        class="tab_exe w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
        ><i class="face_arrow_right">></i>Выходы управления</a>       

        <a style="display:none" href="#" onclick="openTabs(event, 'tab_ok')" class="tab_ok w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
          ><i class="face_arrow_right">></i>Выходы управления</a
        >
        <a style="display:none" href="#" onclick="openTabs(event, 'tab_gsm')" class="tab_gsm w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
          ><i class="face_arrow_right">></i>GSM</a
        >
        <a style="display:none" href="#" onclick="openTabs(event, 'tab_gsm_call_pk4')" class="tab_gsm_call_pk4 w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
        ><i class="face_arrow_right">></i>GSM-Дозвон</a>
        <a
          style="display:none"
          href="#"
          onclick="openTabs(event, 'tab_sms');"
          class="tab_sms w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
          ><i class="face_arrow_right">></i> SMS</a
        >

        <a style="display:none" href="#" onclick="openTabs(event, 'tab_ethernet')" class="tab_ethernet w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
          ><i class="face_arrow_right">></i>LAN</a
        >
        <a style="display:none" href="#" onclick="openTabs(event, 'tab_relay')" class="tab_relay w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
          ><i class="face_arrow_right">></i>Реле</a
        >
        <a style="display:none" href="#" onclick="openTabs(event, 'tab_keys')" class="tab_keys w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
          ><i class="face_arrow_right">></i>Коды пользователей</a
        >
        <a
          style="display:none"
          href="#"
          onclick="openTabs(event, 'tab_logs');"
          class="tab_logs w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
          ><i class="face_arrow_right">></i> Логи</a
        >

        <a style="display:none" href="#" onclick="openTabs(event, 'tab_events')" class="tab_events w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
          ><i class="face_arrow_right">></i>События</a
        >                
        <a
          style="display:none; position: relative;"
          href="#"
          onclick="openTabs(event, 'tab_updateSoft')"
          class="tab_updateSoft w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
          ><i class="face_arrow_right">></i>Обновление ПО <i class="numberCircle" style="display:none; bottom: 18px;
          left: 175px;">1</i></i> <i class="numberCircleSecondCore" style="display:none; bottom: 18px;
        left: 175px;">1</i><i class="numberCircleConfig" style="display:none; bottom: 18px;
        left: 175px;">1</i></i></a
      >

        <a
          style="display:none"
          href="#"
          onclick="openTabs(event, 'tab_updateSoft_PK4')"
          class="tab_updateSoft_PK4 w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
          ><i class="face_arrow_right">></i>Обновление ПО</a
        >
        <a
        id="scenarios"
        style="display:none"
        href="http://localhost:8080/1" target="_blank"
        onclick=""
        class="w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
        ><i class="face_arrow_right">></i>Сценарии</a
        >
        <a style="display:none" href="#" onclick="openTabs(event, 'tab_ip')" class="tab_ip w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
          ><i class="face_arrow_right">></i>IP/UDP</a
        >
        <a style="display:none" href="#" onclick="openTabs(event, 'tab_gprs')" class="tab_gprs w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
          ><i class="face_arrow_right">></i>GPRS</a
        >        
        <a style="display:none" href="#" onclick="openTabs(event, 'tab_other')" class="tab_other w3-bar-item w3-button tablink w3-hover-light-gray w3_bar_alltabs"
          ><i class="face_arrow_right">></i>Расширения</a
        >
        <a
          style="display:none"
          href="#"
          onclick="openTabs(event, 'tab_development')"
          class="tab_development w3-amber w3-bar-item w3-button tablink w3-hover-light-gray"
          ><i class="face_arrow_right">></i>Development</a
        >
      </div>

      <div id="container_main">
        <!-- Вкладка телеметрия -->
        <div id="unknown_device"  class="w3-red" style="height: 48px; padding-left: 18px; padding-top: 8px; display:none;margin-top: 40px;">Данный тип прибора не поддерживается Конфигуратором</div>
        <div id="tab_statusDevice" class="tab_content">
       
          <!-- ТЕЛЕМЕТРИЯ OFF -->
          <div id="tab_telemetriya_off" class="w3-red" style="height: 48px; padding-left: 18px; padding-top: 8px;">Подключение к прибору отсутствует</div>
          <!-- ТЕЛЕМЕТРИЯ ON -->
          <div id="tab_telemetriya_on" style="display:none">
            <div>
            <div style="float:left;">
              <button id='buttonCmdUpdateRKPS' class='w3-btn w3-green' onclick='cmdUpdateRKPS()'>Обновить телеметрию</button>
            </div>
            <div id="status_connect" style="height: 48px; padding-top: 14px; color:mediumspringgreen">
              <span style="padding-left: 12px;">
                Прибор подключен
              </span>
              <span id='outConnectCom'></span>
            </div>                        
            </div>

            <div id="telemetria_1" style="margin-left:16px; overflow-x:auto" class="w3-code border_blue">
              <div><h3 style="display: flex;">Состояние прибора  <span id='spinner' class="loader" style=display: none;"></span> <span id="status_idDev" style="margin-left: 10px;"></span>
             </h3>  </div>
              <table class='tlm_device' width="100%">
                <tr>
                  <!--td><b>ID прибора:</b></td-->
                  <td><b>Дата:</b></td>
                  <td class="telemetria_hide"><b>Корпус:</b></td>
                  <td><b>Активная SIM:</b></td>
                  <td><b>GSM-сигнал:</b></td>
                  <td><b>Связь с сервером:</b></td>
                  <td><b>Питание:</b></td>
                  <td><b id='power_val_name'>Встроенный АКК.:</b></td>
                  <td class="telemetria_hide telemetria_hide_t_208_208"><b>t℃:</b></td>
                  <td class="telemetria_hide"><b>Состояние обслуживания:</b></td>
                  <td class="telemetria_hide"><b class='tr_status_power_ext'>Входное напряжение:</b></td>
                  <!--td class="telemetria_hide"><b class='status_modem_tr'>Версия ядра:</b></td-->
                  <!--td class="telemetria_hide"><b class='status_xcpu_tr'>Версия вспомогательного ядра:</b></td-->
                  <td></td>
                </tr>
                <tr>
                  <!--td><span id="status_idDev"></span></td-->
                  <td><button onclick='loadTimeEvent()' style='cursor:pointer; background: #468966; border:none; color:white;' id="status_time"></button></td>
                  <td class="telemetria_hide"><span id="status_tamper"></span></td>
                  <td><span id="status_activeSim"></span></td>
                  <td><span id="status_gsm"></span></td>
                  <td><span id="status_server"></span></td>
                  <td><span id="status_power"></span></td>
                  <td id="powerBank"><span id="status_power_value"></span></td>
                  <td class="telemetria_hide telemetria_hide_t_208_208"><span id="status_t"></span></td>
                  <td class="telemetria_hide"><span id="status_balance"></span></td>
                  <td class="telemetria_hide"><span class='tr_status_power_ext' id="status_power_ext"></span></td>
                  <!--td class="telemetria_hide"><span class='status_modem_tr' id="status_modem"></span></td-->
                  <!--td class="telemetria_hide"><span class='status_xcpu_tr' id="status_xcpu"></span></td-->
                  <td></td>
                </tr>
             
              </table>
            </div>
            
            
            <div id="telemetria_zona" style="float:left; width:100%; margin-top:0px; margin-left:16px;" class="w3-code border_blue telemetria_AUTCH">
            <h3>Состояние зон:</h3>
            <div id="t_table_lw" style="width:100%; margin: 20px 0 0 20px;"></div>
            <div style="float:right; margin:20px 20px 0 0;">
              <table width="100%">
                <tr>
                  <td>
                    <div class="w3-green lmInfo"></div>
                    В норме
                  </td>
                  <td>
                    <div class="w3-red lmInfo"></div>
                    Нарушена
                  </td>
                  <td>
                    <div class="w3-orange lmInfo"></div>
                    Обрыв
                  </td>
                  <td>
                    <div class="w3-yellow lmInfo"></div>
                    Короткое замыкание
                  </td>
                  <td>
                    <div style="background:gray" class="lmInfo"></div>
                    Исключена
                  </td>
                </tr>
              </table>
            </div>
          </div>


            <div id="telemetria_2" style="margin-left:16px; float:left; width:100%" class="w3-code border_blue telemetria_AUTCH">
              <h3>Состояние разделов:</h3>
              <div id="t_table_part" style="width:100%; margin: 20px 0 0 20px;"></div>
              <div style="float:right; margin:20px 20px 0 0;">
                <table width="100%">
                  <tr>
                    <td>
                      <div class="lmInfo" style="background:#468966; border-radius: 50%"></div>
                      Взят
                    </td>
                    <td>
                      <div class="lmInfo" style="background:gray; border-radius: 50%"></div>
                      Снят
                    </td>
                  </tr>
                </table>
              </div>
            </div>

            <div id="telemetria_3" style="float:left; width:100%; margin-top:0px; margin-left:16px;" class="w3-code border_blue telemetria_AUTCH">
              <h3>Состояние шлейфов:</h3>
              <div id="t_table_lm" style="width:100%; margin: 20px 0 0 20px;"></div>
              <div style="float:right; margin:20px 20px 0 0;">
                <table width="100%">
                  <tr>
                    <td>
                      <div class="w3-green lmInfo"></div>
                      В норме
                    </td>
                    <td>
                      <div class="w3-red lmInfo"></div>
                      Нарушен
                    </td>
                    <td>
                      <div class="w3-orange lmInfo"></div>
                      Обрыв
                    </td>
                    <td>
                      <div class="3-yellow lmInfo"></div>
                      Короткое замыкание
                    </td>
                    <td>
                      <div style="background:gray" class="lmInfo"></div>
                      Исключен
                    </td>
                  </tr>
                </table>
              </div>
            </div>

          

          <div id="telemetria_rkps_pro" style="float:left; width:100%; margin-top:0px; margin-left:16px;" class="w3-code border_black telemetria_AUTCH">
          <div>
           <div id="telemetria_title_on">
             <h3>Состояние радиоканальных устройств:</h3>            
           </div>
          
            <div id="telemetria_title_off">
              <h3>!! Данные о состоянии устройств, полученные при сохранении конфигурации.</h3>
            </div>
           
            <!--div style='float:right; margin-right:50px'>Вид 
              <select id='swapViewBtn' onchange='swapViewTlmtrRkps(this.value)'>
                <option value='table'>Таблица</option>
                <option value='tile'>Плитка</option>
              </select>
            </div-->
            <div style='float:right;'>
              <button id='change' class='w3-btn w3-blue' onclick='resizeRkpsDiv()'>Развернуть</button>
            </div>
            </div>
           
          <div id="t_table_rkps_pro"></div>            
        </div>

            <div id="telemetria_4" style="float:left; width:100%; margin-top:0px; margin-left:16px;" class="w3-code border_blue telemetria_AUTCH">
              <h3>Состояние расширителей:</h3>
              <div id="t_table_ext" style="width:100%; margin: 20px 0 0 20px;"></div>
              <div style="float:right; margin:20px 20px 0 0;">
                <table width="100%">
                  <tr>
                    <td>
                      <div class="w3-green extInfo"></div>
                      Исправен
                    </td>
                    <td>
                      <div class="w3-orange extInfo"></div>
                      Неисправен
                    </td>
                    <td><!-- <div class="w3-yellow exInfo"></div> --></td>
                    <td>
                      <div class="w3-red extInfo"></div>
                      Корпус открыт
                    </td>
                  </tr>
                </table>
              </div>
            </div>

            

            <div id="telemetria_5" style="float:left; width:100%; margin-top:0px; margin-left:16px;" class="w3-code border_blue telemetria_AUTCH">
            <h3>Состояние ОК:</h3>
            <div id="t_table_ok" style="width:100%; margin: 20px 0 0 20px;"></div>
            <div style="float:right; margin:20px 20px 0 0;">
              <table width="100%">
                <tr>
                  <td>
                    <div class="w3-green extInfo"></div>
                    ВКЛ.
                  </td>
                  <td>
                    <div class="w3-gray extInfo"></div>
                    ВЫКЛ.
                  </td>                  
                </tr>
              </table>
            </div>
           </div>
          



          </div>    
        </div>

        <!-- ОБЩИЕ -->
        <div id="tab_main" class="w3-container tab_content">
          <div class="w3-code border_blue">
            
            <div id="tab_main_gi"></div>
            <div id="tab_main_ks3"></div>
            <div id="tab_main_upr"></div>
            <div id="tab_main_oa"></div>
            <div id="tab_main_bv"></div>
            <div id="tab_main_im"></div>
            <div id="tab_main_hs"></div>
            <div id="tab_main_kr"></div>
            <div id="tab_main_km"></div>
            <div id="tab_main_dc"></div>
             
            
            
            <div id="tab_main_ks1"></div>
            <div id="tab_main_ks2"></div>
            <div id="tab_main_upr"></div>
            <!--div id="tab_main_ph1"></div-->
            <!--div id="tab_main_ph2"></div-->
            
            <!--div id="tab_main_cb1_0"></div-->
            <!--div id="tab_main_cb1_1"></div-->
            
            <!--div id="tab_main_cb2_0"></div-->
            <!--div id="tab_main_cb2_1"></div-->
            <!--div id="tab_main_ct1"></div-->
            <!--div id="tab_main_ct2"></div-->
            <!--div id="tab_main_ca"></div-->
            <!--div id="tab_main_ms"></div-->
            <div id="tab_main_es"></div>
            
            <div id="tab_main_xo"></div>
            <div id="tab_main_ci"></div>
            <div id="tab_main_if"></div>
            <div id="tab_main_al"></div>
            
            <div id="tab_main_rc"></div>
            <div id="tab_sms_canal"></div>
            <div id="tab_bluetooth"></div>

          </div>

          <div id='zapret_group_main' class="w3-code border_red" style='display:none'>
            <table width="100%">
              <tr>
                <td width="50%" style="text-align:left;">Запрещена постановка без:</td>
                <td><div id="zapret_gprs"></div></td>
                <td><div id="zapret_akb"></div></td>
                <td><div id="zapret_220v"></div></td>
              </tr>
            </table>

            <div id="tab_main_ez"></div>
            <div id="tab_main_ed"></div>
            <div id="tab_main_ti"></div>
            <div id="tab_main_el"></div>
            <div id="tab_main_tp"></div>
            <div id="tab_main_pr"></div>
            
          </div>   
          <div id='zapret_connection' style='display:none'  class="w3-code border_blue">
          <h4>Параметры проверки каналов связи</h4>
          <div id="tab_main_fc0"></div>
          <div id="tab_main_fc1"></div>
          </div>       
        </div>

        <!-- РЕЖИМЫ -->
        <div id="tab_mode" class="w3-container tab_content"></div>

        <!-- ИНДИКАЦИЯ -->
        <div id="tab_indication" class="w3-container tab_content"></div>

       

        <!-- ОБЩИЕ ПК4 -->
        <div id="tab_main_pk4" class="w3-container tab_content">
        <div class="w3-code border_blue">
        <h4>Конфигурация<span id='key_jupiter'> "по-умолчанию"</span></h4>
          <div id="tab_main_pk4_ks3"></div>                
          <div id="tab_main_pk4_ks1"></div>
          <div id="tab_main_pk4_ks2"></div>
          <div id="tab_main_pk4_upr"></div>
          <div id="tab_main_pk4_oa"></div>
        </div>

        <div class="w3-code border_blue">
        <h4>Номера ипользуемых SIM-карт (для справки, прибором в работе не используется)</h4>
          <div id="tab_main_pk4_ph1"></div>
          <div id="tab_main_pk4_ph2"></div>
         
        </div>

        <div class="w3-code border_blue">
         <h4>Контроль баланса</h4> 
         
          <div id="tab_main_pk4_cb1_1"></div>
          <div id="tab_main_pk4_cb1_0"></div>
          <div id="tab_main_pk4_ct1"></div>
            <hr>
            <div id="tab_main_pk4_cb2_1"></div>
            <div id="tab_main_pk4_cb2_0"></div>
            <div id="tab_main_pk4_ct2"></div>
        </div>

        <div class="w3-code border_blue">
          <h4>Параметры проверки каналов связи</h4>
          <div id="tab_main_pk4_fc0"></div>
          <div id="tab_main_pk4_fc1"></div>
        </div>

        <div style="display:none" class="w3-code border_blue">
            
          <div id="tab_main_pk4_gi"></div>      
          <div id="tab_main_pk4_hs"></div>                          
          <div id="tab_main_pk4_ca"></div>
          <div id="tab_main_pk4_ms"></div>
          <div id="tab_main_pk4_es"></div>
          <div id="tab_main_pk4_em"></div>
          <div id="tab_main_pk4_xo"></div>
          <div id="tab_main_pk4_ci"></div>
          <div id="tab_main_pk4_if"></div>
          <div id="tab_main_pk4_al"></div>
        
        <div id="tab_main_pk4_rc"></div>        

      </div>
        </div>

        <!-- РЕЖИМЫ ПК4-->
        <div id="tab_mode_pk4" class="w3-container tab_content">
        <div class='w3-code border_blue'>
          <h4>Режим выбора SIM-карты</h4>        
          <div id="tab_mode_pk4_ms"></div>  
          <div id="tab_gsm_ca_pk4"></div>  
          <div id="tab_gsm_cm_0_pk4"></div>  
          <div id="tab_gsm_cm_1_pk4"></div>  
        </div>

        <div class='w3-code border_red'>
          <h4>Режимы функционирования охранного прибора</h4>          
          <div id="tab_mode_pk4_es"></div>  
          <div id="zapret_gprs_pk4"></div>  
        </div>

        <div class='w3-code border_black'>
          <h4>Общие режимы</h4>  
          <div id="tab_mode_pk4_log"></div>          
          <div id="tab_mode_pk4_huk"></div>          
          <div id="tab_mode_pk4_lan"></div>          
          <div id="tab_mode_pk4_pr"></div>          
          <div id="tab_mode_pk4_rc"></div>          
          <div id="tab_mode_pk4_tu"></div>          
        </div>

        </div>

        <!-- ИНДИКАЦИЯ ПК4-->
        <div id="tab_indication_pk4" class="w3-container tab_content">        
        <div class='w3-code border_blue'>
        <h4>Параметры формирования сообщения "Дежурный режим":</h4>
        <div id="tab_indication_pk4_om"></div>
        <div id="tab_indication_pk4_on"></div>
        </div>
        <div class='w3-code border_red'>
        <h4>Индикация и сигнализация:</h4>
        <div id="tab_main_pk4_bv"></div>
        <div id="tab_main_pk4_sz"></div>
        <div id="tab_main_pk4_st"></div>
        <div id="tab_main_pk4_im"></div>
        <div id="tab_main_pk4_el"></div>
        <div id="tab_main_pk4_ti"></div>
        </div>
        <div class='w3-code border_black'>
        <h4>Выносной индикатор:</h4>
        <div id="tab_main_ed_pk4"></div>
        <div id="tab_main_pk4_ez"></div>
        <div id="tab_main_pk4_en"></div>
        </div>

        </div>
        

        <!-- ШЛЕЙФЫ ПК4-->
        <div id="tab_sensors_pk4" class="w3-container tab_content">
          <div class='w3-code border_blue'>
            <h4>Список Шлейфов</h4>
            <div id='tab_sensors_pk4_table'></div>
            <div id='tab_sensors_pk4_xo'></div>
            <div id='tab_sensors_pk4_em'></div>
              <div><h4>Фиксация и восстановление шлейфов:</h4>
                <div id='tab_sensors_pk4_lc'></div>
            </div>
          </div>
          <div class="w3-code border_black">
          
          <div id="tab_sensors_delay_pk4"></div>
        </div>
        </div>

        <!-- РЕЛЕ ПК4-->
        <div id="tab_rele_pk4" class="w3-container tab_content">
        <!-- ОК -->
         
          <div class="w3-code border_blue">
         
            <div id="tab_ok_table_v3"></div>
          </div>
         
        <div class='w3-code border_blue'>
            <h4>Режимы работы реле</h4>
            <div id='tab_rele_pk4_table'></div>                      
          </div>
          <div id="work_rele" style="display:none" class='w3-code border_red'>
          Параметры работы реле
          <div id='tab_rele_pk4_tb'></div>
          <div id='tab_rele_pk4_br'></div>              
          </div>
        </div>

        <!-- КЛЮЧИ ПК4-->
        <div id="tab_keys_pk4" class="w3-container tab_content">
        <div class='w3-code border_blue'>
        Коды пользователей
        <div id='tab_keys_pk4_user'></div>
        </div>
        </div>

        <!-- CМС ПК4-->
        <div id="tab_sms_pk4" class="w3-container tab_content"></div>

        <!-- СМС-К ПК4-->
        <div id="tab_sms_k_pk4" class="w3-container tab_content"></div>

        <!-- GSM-ДОЗВОН ПК4-->
        <div id="tab_gsm_call_pk4" class="w3-container tab_content">
        <div id='ds_off' class='w3-code border_blue'><div id='tab_gsm_call_pk4_ds'></div></div>
        <div id='dp_off' class='w3-code border_blue'><div id='tab_gsm_call_pk4_dp'></div></div>
        <div  class='w3-code border_blue'><div id='tab_gsm_call_pk4_dn'></div></div>
        </div>

        <!-- IP/UDP ПК4-->
        <div id="tab_ip_udp_pk4" class="w3-container tab_content">
            
            <div class='w3-code border_blue'><h4>Параметры идентификации</h4>
              <div id='tab_ip_udp_pk4_id'></div>
              <div id='tab_ip_udp_pk4_key'></div>
            </div>

            <div class='w3-code border_blue'>
              <div><h4>Период тестовых сообщений IP-канала</h4>
                <div id='tab_ip_udp_pk4_period1'></div>
                <div id='tab_ip_udp_pk4_period2'></div>
                <hr>
              </div>
              <div id='tab_ip_udp_pk4_report'></div>
              <div id='tab_ip_udp_pk4_max'></div>
            </div>
        </div>

        <!-- GPRS ПК4-->
        <div id="tab_gprs_pk4" class="w3-container tab_content">        
        <div id="tab_main_pk4_sm" class="w3-code border_red">
        
        </div>
        <div id="tab_main_pk4_ii" class="w3-code border_red"></div>

        <div id="tab_sim_1_pk4" class="w3-code border_red" style="width:48%; float:left">
        <h4>SIM-Карта 1: </h4>
        <div id="tab_main_ph1_pk4"></div>
        <div id="tab_main_cb1_0_pk4"></div>
        <div id="tab_main_cb1_1_pk4"></div> 
        <div id="tab_main_ct1_pk4"></div>                       
        <div id="tab_sim_1_apn_pk4_pk4" class='gsm_lock_sm_pk4'></div>
        <div id="tab_sim_1_conf_block_pk4">
        <div class="tab_sim_1_conf_pk4" id="tab_sim_1_apn_conf_pk4"></div>
        <div class="tab_sim_1_conf_pk4" id="tab_sim_1_apn_conf_gl_pk4"></div>
        <div class="tab_sim_1_conf_pk4" id="tab_sim_1_apn_conf_gp_pk4"></div>
        </div>
        <div id="tab_sim_1_ipUdp1_pk4"></div>
        <div id="tab_sim_1_ipUdp2_pk4"></div>
        <hr>
        <h4>Серверы приема сообщений: </h4>
        <div id="tab_sim_01_ipUdp1_pk4" class='gsm_lock_sm_pk4'></div>        
        <div id="tab_sim_01_ipUdp2_pk4" class='gsm_lock_sm_pk4'></div>        
        <div id="tab_sim_01_ipUdp3_pk4" class='gsm_lock_sm_pk4'></div>
        
      </div>
      
      <div id="tab_sim_2_pk4" class="w3-code border_blue" style="width:48%; float:right">          
        <h4>SIM-Карта 2: </h4>
        <div id="tab_main_ph2_pk4"></div>
        <div id="tab_main_cb2_0_pk4"></div>
        <div id="tab_main_cb2_1_pk4"></div>
        <div id="tab_main_ct2_pk4"></div>
        <div class='gsm_lock_sm_pk4' id="tab_sim_2_apn_pk4"></div>
        <div id="tab_sim_2_conf_block_pk4">
        <div class="tab_sim_2_conf_pk4" id="tab_sim_2_apn_conf_pk4"></div>
        <div class="tab_sim_2_conf_pk4" id="tab_sim_2_apn_conf_gl_pk4"></div>
        <div class="tab_sim_2_conf_pk4" id="tab_sim_2_apn_conf_gp_pk4"></div>
      </div>

        <div id="tab_sim_2_ipUdp3_pk4"></div>
        <div id="tab_sim_2_ipUdp4_pk4"></div>
        <hr>
        <h4>Серверы приема сообщений: </h4>
        <div id="tab_sim_02_ipUdp4_pk4" class='gsm_lock_sm_pk4'></div>        
        <div id="tab_sim_02_ipUdp5_pk4" class='gsm_lock_sm_pk4'></div>
        <div id="tab_sim_02_ipUdp6_pk4" class='gsm_lock_sm_pk4'></div>

        
      </div>
        
        
        
        </div>

        <!-- ETHERNET ПК4-->
        <div id="tab_ethernet_pk4" class="w3-container tab_content">
          <div class='w3-code border_blue'>
            <h4>Параметры Ethernet-подключения</h4>
            <label><input type='radio' class='w3-radio' name='tab_ethernet_pk4_cnt'> Выкл.</label>
            <label><input type='radio' class='w3-radio' name='tab_ethernet_pk4_cnt'> Ethernet</label>
            <div id="tab_ethernet_pk4_connect">                        
            </div>
            <div id="tab_ethernet_ip1_pk4"></div>  
          </div>

          <div class='w3-code border_black'>
            <h4>Параметры серверов приема сообщений</h4>
            <div id="tab_ethernet_pk4_param"></div>
          </div>
        </div>

        <!-- РАСШИРЕНИЯ ПК4-->
        <div id="tab_plugin_pk4" class="w3-container tab_content">
        

        <div id="tab_hw1" class='w3-code border_black'>
        <h4>Подключенные расширители</h4>
          <div id='tab_hw1_table'></div>
        </div>
        
        
        </div>

        <!-- ШЛЕЙФЫ -->
        <div id="tab_sensors" class="w3-container tab_content">
          <div class="w3-code border_blue">
            <div style="float:left"><h4>Список шлейфов: </h4></div>
            <div style="float:right">
              <label><input class="w3-check"  id="section_excluded" type="checkbox" checked onchange="showHideExcludedSens(this)" /> Отображать исключенные шлейфы расширителей</label>
            </div>
            <div id="tab_sensors_list"><br />Шлейфы не обнаружены</div>
            <div>
              <table>
                <tr>
                  <td>
                    <div class="w3-green lmInfo"></div>
                    В норме
                  </td>
                  <td>
                    <div class="w3-red lmInfo"></div>
                    Нарушен
                  </td>
                  <td>
                    <div class="w3-orange lmInfo"></div>
                    Обрыв
                  </td>
                  <td>
                    <div class="w3-yellow lmInfo"></div>
                    Короткое замыкание
                  </td>
                  <td>
                    <div  style="background:gray" class="lmInfo"></div>
                    Исключен
                  </td>
                 
                </tr>
              </table>
            </div>
          </div>

          <div id="tab_sensors_temperature" class="w3-code border_red">
            <b>Пороги датчика температуры: </b>
            <table style="width:100%">
              <tr>
                <td><div id="tab_sensors_temp_max"> Датчики не обнаружены</div></td>
                <td><div id="tab_sensors_temp_min"></div></td>
              </tr>
            </table>
          </div>

          <div class="w3-code border_black">
            <h4>Задержка на выход для: </h4>
            <div id="tab_sensors_delay"></div>
          </div>

          <div class="w3-code border_black">
            <h4>Фиксация и восстановление шлейфов: </h4>
            <div id="tab_sensors_fixed"></div>
          </div>
        </div>

        <!-- Радио устройства -->
        <div id="tab_r_device" class="w3-container tab_content">
        <div class="w3-code border_black" style="min-height:60px">
            <h4>Параметры: </h4>            
            <div id="tab_r_device_config"></div>
            <div id="tab_r_device_mac"></div>
            <div id="zapret_xxfa"></div> 
          </div>  
          <div class="w3-code border_blue" style="min-height:60px">
            <h4>Список радиоканальных устройств: </h4>
            
            <div style="float:right">
              <label style="float:left">
              <button id='modal_r_device_delete_All' style='margin-bottom:7px'  type="button" class="w3-bar-item w3-button w3-red w3-round" onclick="setDeleateAllRadio()">
                  &#9851; Удалить Все
                </button>
                <button style='margin-bottom:7px' class=" w3-btn w3-green w3-border w3-border-green" onclick="open_modal_Rdevice('-1',null)">+ Добавить устройство</button></label>
            </div>
            <div id="tab_r_device_list"></div>
          </div>
        </div>

        <!-- Разделы -->
        <div id="tab_sections" class="w3-container tab_content">
          <div class="w3-code border_black">
            <h4>Фиксация и восстановление зон: </h4>
            <div id="tab_sensors_fixed_r"></div>
            <div id="tab_main_em"></div>
          </div>

          <div id="autoTuneBox" class="w3-code border_black">            
          <h4>Автонастройка зон:</h4>
          <div><button id="autoTuneBtn" class="w3-btn w3-bar w3-border w3-border-blue">Переназначить номера зон</button></div>
          </div>

         
          <div id="tab_section_list"></div>          

          <div class="" style="min-height: 70px;border-radius: 30px;">
           <div id='btn_section_list_new' onclick="section_list_new('-1')"; class='w3-add-new-sect w3-hover-shadow'"> + Добавить новый раздел</div>
          
        </div>
        <div class="w3-code border_black" id="new-delay-on-output">
            <b>Задержка на выход: </b>
            <div style='line-height:1;' id="tab_sensors_delay_208"></div>    
          </div>
        </div>

        <!-- Исполнительные устройства -->
        <div id="tab_exe" class="w3-container tab_content">
          <div class="w3-code border_black" style="min-height:60px">
          <h4>Выходы управления: </h4>
            <div id="tab_exe_list">
            </div>
          </div>
        </div>

        <!-- Расширители -->
        <div id="tab_extender" class="w3-container tab_content">
          <div class="w3-code border_blue">
            <h4>Список Расширителей: </h4>
            <table>
              <tr>
                <td>
                  <div id='controlSpeedRs485'>
                    <label
                      >Скорость RS-485
                      <select name="es" id="speedRs485">
                        <option value="1">9600 бод/с</option>
                        <option value="2">19200 бод/с</option>
                        <option value="3">28800 бод/с</option>
                        <option value="4">38400 бод/с</option>
                        <option value="5">57600 бод/с</option>
                        <option value="6">115200 бод/с</option>
                      </select>
                      <button onclick="setSpeedRs485()" class="w3-border w3-border-green w3-btn w3-white">Установить</button>
                    </label>
                  </div>
                </td>
                <td><div style="float:right"></div></td>
              </tr>
            </table>
            <div id="tab_main_three"></div>
            <div id="tab_extender_list"></div>
          </div>
        </div>

        <!-- Зоны -->
        <div id="tab_zone" class="w3-container tab_content">
          <div class="w3-code border_blue">
            <b>Список Зон: </b>
            <div id="tab_zone_list"></div>
          </div>
        </div>

        <!-- ОК -->
        <div id="tab_ok" class="w3-container tab_content">
          <div class="w3-code border_blue">
            <h4>Выходы управления: </h4>
            <div id="tab_ok_table"></div>
          </div>
        </div>

        <!-- GSM -->
        <div id="tab_gsm" class="w3-container tab_content">

        
                
        
        <div style="display:none" class="w3-code border_black tab_gsm_ps_key">
            <b>Пароль блокировки настроек: </b>
            <div id="tab_gsm_ps_key"></div>
        </div>

        <div class="w3-code border_black tab_main_sm" style="width:100%; float:left; display:none">
          <h4>Подключение по GPRS: </h4>
            <div id='tab_main_sm'>            
            </div>
        </div>
        <div id="tab_gsm_ii"  class="w3-code border_black tab_main_sm" style="width:100%; float:left;></div>  
          <div class="w3-code border_black gsm_lock_sm" style="width:100%; float:left">
          <h4>Текущее подключение по IP/UDP: </h4>
          <table style="width:100%">
            <tr>
              <td width="45%">IP <input id="tab_gsm_ip_t" disabled></td>
              <td width="10%"></td>
              <td width="45%">UDP <input id="tab_gsm_udp_t" disabled></td>
            </tr>
          </table>
        </div>
  
     
          <div id="tab_sim_1" class="w3-code border_red" style="width:50%; float:left">
            <h4>SIM-Карта 1: </h4>
            <div id="tab_main_ph1"></div>
            <div id="tab_main_cb1_0"></div>
            <div id="tab_main_cb1_1"></div> 
            <div id="tab_main_ct1"></div>                       
            <div id="tab_sim_1_apn" class='gsm_lock_sm'></div>
            <div id="tab_sim_1_conf_block">
            <div class="tab_sim_1_conf" id="tab_sim_1_apn_conf"></div>
            <div class="tab_sim_1_conf" id="tab_sim_1_apn_conf_gl"></div>
            <div class="tab_sim_1_conf" id="tab_sim_1_apn_conf_gp"></div>
            </div>
            <div id="tab_sim_1_ipUdp1"></div>
            <div id="tab_sim_1_ipUdp2"></div>

            <div id="tab_sim_01_ipUdp1" class='gsm_lock_sm'></div>
            <div id="tab_sim_01_ipUdp2" class='gsm_lock_sm'></div>
            <div id="tab_sim_01_ipUdp3" class='gsm_lock_sm'></div>
            <button class=" w3-btn w3-white w3-border w3-border-red w3-block btnBlockGsm" onclick="modalGsmBlock()">Настройки IP/UDP</button>
          </div>
          <!--div id="tab_sim_0" class="w3-code" style="width:2%; float:left"></div-->
          <div id="tab_sim_2" class="w3-code border_blue" style="width:48%; float:right">          
            <h4>SIM-Карта 2: </h4>
            <div id="tab_main_ph2"></div>
            <div id="tab_main_cb2_0"></div>
            <div id="tab_main_cb2_1"></div>
            <div id="tab_main_ct2"></div>
            <div class='gsm_lock_sm' id="tab_sim_2_apn"></div>
            <div id="tab_sim_2_conf_block">
            <div class="tab_sim_2_conf" id="tab_sim_2_apn_conf"></div>
            <div class="tab_sim_2_conf" id="tab_sim_2_apn_conf_gl"></div>
            <div class="tab_sim_2_conf" id="tab_sim_2_apn_conf_gp"></div>
          </div>

            <div id="tab_sim_2_ipUdp3"></div>
            <div id="tab_sim_2_ipUdp4"></div>

            <div id="tab_sim_02_ipUdp4" class='gsm_lock_sm'></div>
            <div id="tab_sim_02_ipUdp5" class='gsm_lock_sm'></div>
            <div id="tab_sim_02_ipUdp6" class='gsm_lock_sm'></div>

            <button class=" w3-btn w3-white w3-border w3-border-blue w3-block btnBlockGsm" onclick="modalGsmBlock()">Настройки IP/UDP</button>
          </div>          


          <div style="float:left; width:100%; margin-top:0px" class="w3-code border_blue gsm_lock_sm">
            <b>Настройка операторов: </b>
            <table style="width:100%" class="w3-table w3-table-all">
              <tr>
                <td>Оператор</td>
                <td>APN-сервер</td>
                <td>Логин</td>
                <td>Пароль</td>
              </tr>
              <tr>
                <td>Билайн</td>
                <td><div id="tab_sim_3_apn_conf"></div></td>
                <td><div id="tab_sim_3_apn_conf_gl"></div></td>
                <td><div id="tab_sim_3_apn_conf_gp"></div></td>
              </tr>
              <tr>
                <td>МТС</td>
                <td><div id="tab_sim_4_apn_conf"></div></td>
                <td><div id="tab_sim_4_apn_conf_gl"></div></td>
                <td><div id="tab_sim_4_apn_conf_gp"></div></td>
              </tr>
              <tr>
                <td>Мегафон</td>
                <td><div id="tab_sim_5_apn_conf"></div></td>
                <td><div id="tab_sim_5_apn_conf_gl"></div></td>
                <td><div id="tab_sim_5_apn_conf_gp"></div></td>
              </tr>
              <tr>
                <td>Теле2</td>
                <td><div id="tab_sim_6_apn_conf"></div></td>
                <td><div id="tab_sim_6_apn_conf_gl"></div></td>
                <td><div id="tab_sim_6_apn_conf_gp"></div></td>
              </tr>
            </table>

            <div id="tab_mts"></div>
            <div id="tab_tele2"></div>
            <div id="tab_beeline"></div>
            <div id="tab_megafon"></div>
          </div>

          <div style="float:left; width:100%; margin-top:0px" class="w3-code border_black">          
          
            <div id="tab_gsm_ms"></div>  
            <div id="tab_gsm_cm_0"></div>            
            <div id="tab_gsm_cm_1"></div>
            <div id="tab_gsm_ca"></div>
           
            <div id="tab_gsm_at1"></div>
            <div id="tab_gsm_conf"></div>
          </div>

         

          <div id="tab_sim_1_sms" class="w3-code border_black all_default_element" style="width:100%; float:left; display:none;">
            <b>Номера телефонов для отправки SMS-сообщений </b>
            <table style="width:100%">
              <tr>
                <td width="45%"><div id="tab_sim_1_numberSms"></div></td>
                <td width="10%"></td>
                <td width="45%"><div id="tab_sim_2_numberSms"></div></td>
              </tr>
            </table>
          </div>
         
          <div id="tab_sim_6_sms" class="w3-code border_black all_default_element" style="width:100%; float:left; display:none;">
          <div id="tab_gsm_saturn">
          <b>Отправка SMS-сообщений </b>
                   <div id="tab_gsm_saturn_codirovka"></div>
               
      </div>
            
            <table style="width:100%;">
            <tbody style='display:flex';>
            <tr style='display:flex; flex-direction:column;width: 100%;'>
                <td  ><div id="tab_sim_1_number"></div></td>
                <td width="10%"></td>
                <td ><div id="tab_sim_2_number"></div></td>
              
              <td  ><div id="tab_sim_3_number"></div></td>
              </tr>
              <tr style='display:flex; flex-direction:column;width: 100%;'>
              <td  ><div id="tab_sim_4_number"></div></td>
               
              <td  ><div id="tab_sim_5_number"></div></td>
              
              <td ><div id="tab_sim_6_number"></div></td>
              </tr>
            </tbody>
           
            </table>
          </div>


          <div style="display:none; float:left; width:100%" class="w3-code border_black tab_gsm_show_om">
             <div id="tab_gsm_om"></div> 
          </div> 


          <div style="display:none; float:left; width:100%" class="w3-code border_black tab_gsm_test_key">
          <div>
            <h4>Период тестовых сообщений IP-канала</h4>
            <div id='tab_ip_udp_pk5_period1'></div>
            <div id='tab_ip_udp_pk5_period2'></div>              
          </div>
        </div>

        <div style="display:none; float:left; width:100%" class="w3-code border_black tab_gsm_gnss_key">
          <div>
            
            <div id='tab_gsm_gnss_input'></div>            
          </div>
        </div>

        </div>

        <!-- РЕЛЕ -->
        <div id="tab_relay" class="w3-container tab_content"></div>

        <!-- КЛЮЧИ -->
        <div id="tab_keys" class="w3-container tab_content">
          <div id="tab_keys_interface" class="w3-code border_black">
            <h4>Параметры использования интерфейса ТМ: </h4>
            <div id="tab_keys_tm"></div>
            <div id="tab_keys_ds"></div>
          </div>

          <div id="tab_keys_keys" class="w3-code border_blue">
            <div style="float:left"><h4>Коды пользователей: </h4></div>
            <div  style="float:right">
              <label id="learnMode" style="float:left"><input id="inputLearnMode" class="w3-check" onchange="setModeLearnKey(this)" type="checkbox" /> Режим обучения ключам</label
              ><label style="float:left; padding-left: 20px">
                <button style='margin-bottom:6px' class=" w3-btn w3-white w3-border w3-border-green" onclick="modalAddKey('-1')">+ Добавить новый</button></label
              >
            </div>
            <div id="tab_keys_ua"></div>
          </div>
        </div>

        <!-- Логи -->
        <div id="tab_logs" class="w3-container tab_content">
          <div id="events_block" class="w3-code border_black">
            <h4>Логи: </h4><br /><button onclick="loadLogs()" id="btn_loadLogs" class="custom-file-upload  w3-btn w3-white w3-border w3-border-blue">Загрузить из прибора</button>
            <!-- span id="TotalLogs"></span -->
            <button disabled onclick="downloadLogs()" id="dwnlLog" class="custom-file-upload  w3-btn w3-white w3-border w3-border-green">Сохранить как</button>
            <button id="btn_clearLogs" onclick="clearLogs()" class="custom-file-upload  w3-btn w3-white w3-border w3-border-red">Очистить в приборе</button>
          </div>
          <div><div id="logs_list" style="display:none" class="w3-code border_black"></div></div>
        </div>

        <!-- СМС -->
        <div id="tab_sms" class="w3-container tab_content">
          <div id="sms_block" class="w3-code border_black">
            <h4>Группы событий для отправки СМС </h4>
            <div id="tab_sms_codirovka"></div>
            <div id="tab_sms_mode"></div>
            
            <div id="tab_sms_phone"></div>
          </div>
          <div id="sms_k_block" class="w3-code border_black">
            <h4>Номера телефонов для отправки СМС-сообщений по постановке/снятию </h4>
            <div id="tab_sms_phone_k"></div>            
          </div>
        </div>
        <!-- ETHERNET -->
        <div id="tab_ethernet" class="w3-container tab_content">
        <div id="tab_ethernet_param1" class="w3-code border_red">
            <h4>Режим работы прибора по каналам LAN: </h4>            
            <div id="tab_ethernet_ie"></div>                        
        </div>

        <div id="tab_ethernet_param2" class="w3-code border_black w3-animate-left">
        <h4>Параметры Ethernet-подключения: </h4>            
        <div id="tab_ethernet_ma"></div>
            <div id="tab_ethernet_ip"></div>            
            <div id="tab_ethernet_ip1"></div>            
            <div id="tab_ethernet_ip3"></div>            
            <div id="tab_ethernet_ip2"></div>            
        </div>      

        <div id="tab_ethernet_param5" class="w3-code border_black w3-animate-left">
        <b>Параметры Wi-Fi подключения: </b>                    
            <div id="tab_ethernet_mb"></div>            
            <div id="tab_ethernet_ws">
            </div>            
            <div id="tab_ethernet_wk"></div>                        
            <div id="tab_ethernet_mp"></div>                        
        </div>
        <div id="modal-error" style="background-color:white; display: flex;
        justify-content: center;height: 4em;
        align-items: center; display:none; position: fixed;
        left: 22.5em;
        width: 78%;">
        <div style=" display:flex; flex-direction: column;">
        <span id="danger_name" > Параметр Wi-Fi: </span>
        <span id="danger" style="color:red"> Возникла непредвиденная ошибка </span>
        </div>
       
        </div>

        

        <div id="tab_ethernet_param3" class="w3-code border_red">
            <h4>Параметры DNS-сервера: </h4>            
            <div id="tab_ethernet_ip4"></div>                        
        </div>
        <div id="tab_ethernet_param6" class="w3-code border_blue">
        <h4>Список найденных сетей: </h4>
       <div id="tab_wifi_param">
        
           
        </div>
        <button class=" w3-btn w3-white w3-border w3-border-red w3-block btnBlockGsm" onclick="modalGsmBlock()">Разблокировать</button>          
    </div>

        <div id="tab_ethernet_param4" class="w3-code border_blue">
            <h4>Параметры серверов приема сообщений: </h4>
            <table class="w3-table w3-table-all" width=100%"">
              <tbody>
                <tr style='background-color:#2196f3'><td>№</td><td>IP адрес</td><td>UDP-порт</td></tr>
                <tr><td>1</td><td><div id="tab_ethernet_gs7_0"></div></td><td><div id="tab_ethernet_gs7_1"></div></td></tr>
                <tr><td>2</td><td><div id="tab_ethernet_gs8_0"></div></td><td><div id="tab_ethernet_gs8_1"></div></td></tr>
                <tr><td>3</td><td><div id="tab_ethernet_gs9_0"></div></td><td><div id="tab_ethernet_gs9_1"></div></td></tr>
              </tbody>
            </table>  
            <button class=" w3-btn w3-white w3-border w3-border-red w3-block btnBlockGsm" onclick="modalGsmBlock()">Разблокировать</button>          
        </div>
        </div>


        <!-- События -->
        <div id="tab_events" class="w3-container tab_content">
          <div id="events_block" class="w3-code border_black">
            <h4>События: </h4><br /><button id="loadEvent_btn" onclick="loadEvent()" class="custom-file-upload  w3-btn w3-white w3-border w3-border-blue">Загрузить</button>
            <button id="loadSaveEvent_btn" disabled onclick="loadSaveEvent()" class="custom-file-upload  w3-btn w3-white w3-border w3-border-green">Сохранить</button>
            <button id="loadNoSendEvent" style='display:none' onclick="loadNoSendEvent()" class="custom-file-upload  w3-btn w3-white w3-small w3-border w3-border-green">Пометить все не переданные сообщения как "не передавать"</button>
            <span id="TotalEvents"></span>
            
          </div>
          <div><div  style="height: 700px; overflow: auto;" id="events_list" class="w3-code border_black"></div></div>
        </div>

        <!-- Обновление ПО -->
        <div id="tab_updateSoft" class="w3-container tab_content">
        
          <div id="tab_updateSoft_modem" >
          <div class='tab_idDev_updateSoft' style="display:none; color: white;"><h3>Состояние прибора <span id="status_idDev_updateSoft"></span></h3></div>
          <div class="w3-code border_blue status_modem_tr">
          <b>Основная прошивка </b><br />
          Текущая версия <span id="status_modem_tab"></span> <br />
          <br />
          <div style="
          display: flex;
          justify-content: space-between;
      ">
           
            <div id="satus_new_version" style="display:none;         position: relative;">
            Доступна версия прошивки<i class="numberCircle">1</i></i>  <span id="number_new_ver" style="margin-left: 20px;"></span><button  onclick="openWarningModalUpdatePO(1)" id="button_main_online" style="margin-left:15px;"class="custom-file-upload w3-bar-item w3-button">Обновить</button> 
          </div>
 
<div> <button  onclick="autoCheckNewPO()" id="button_main_online" class="custom-file-upload w3-bar-item w3-button">Проверить обновления</button></div>
           </div>
          
            </div>
         
          </div>
          <div class="w3-code border_blue status_modem_tr">
          
 
<div style="
display: flex;
justify-content: space-between;
padding: 20px 0px;
">
<div style="display:none;" id="error_format">Неправильный формат файла! Выберите .bin или .efp</div>
<div style="display:none;" id="empty_po">Отсутствует обновления основной прошивки</div>
<div id="satus_new_version_custom" style="display:none;  position: relative;">
            Доступна версия прошивки  
            <span id="number_new_ver_custom"> </span>
            <button  onclick="openWarningModalUpdatePO(2)" id="button_main_ofline"  class="custom-file-upload w3-bar-item w3-button">Обновить</button> 
            <button style="margin-left:25px" id="button_main_core_burn"   onclick="openWarningModalUpdatePO(3)" class="custom-file-upload w3-bar-item w3-button">Обновить</button>
</div>
<div style="display:none;" id="empty_po_sec">Отсутствует обновления дополнительной прошивки</div>
<div id="satus_new_version_secondcore" style="display:none;  position: relative;">
            Доступна новая версия дополнительной прошивки  
            <span id="number_new_ver_secondcore"> </span>
            <button  onclick="openWarningModalUpdatePO(5)" id="button_main_ofline_secondcore"  class="custom-file-upload w3-bar-item w3-button">Обновить</button> 
            <button style="margin-left:25px" id="button_sec_core_burn"   onclick="openWarningModalUpdatePO(3)" class="custom-file-upload w3-bar-item w3-button">Обновить</button>
</div>
           
            <div id="open-file-upload">
<label for="file-upload-main-core" id="input-file-upload-main-core" class="custom-file-upload w3-bar-item w3-button">
<i class="fa fa-cloud-upload"></i>Выбрать файл прошивки
</label>

<input id="file-upload-main-core" type="file" />
</div>
                            
<div>
<button  onclick="uploadZipArchive()" id="button_main_online" class="custom-file-upload w3-bar-item w3-button">Скачать архив прошивок</button>
    </div>  
    </div>                     
                 
  </div>
 

<div style="display:none">
<p class="note">Выберети zip-файл для поиска обновления:</p>
<label for="file-zip" id="input-file-upload-zip" class="custom-file-upload w3-bar-item w3-button">
 <i class="fa fa-cloud-upload"></i>Выбрать zip файл
</label>
<input  id="file-zip" type="file"/>
<button onclick="sendZIP('main)" style="display:" id="button_main_zip" class="w3-border w3-border-orange w3-btn w3-white">Перепрошить из Zip</button>
</div>
<div id="tab_updateSoft_xcpu"  class="w3-code border_red status_xcpu_tr">
<b>Вспомогательное ядро </b><br />
Текущая версия <span id="status_xcpu_tab"></span> <br />
<br />
<div id="satus_new_version_second" style="display:none; position: relative;">
Доступна версия прошивки<i class="numberCircleSecondCore">1</i></i>  <span id="number_new_ver_second" style="margin-left: 20px;"></span><button  onclick="openWarningModalUpdatePO(4)" id="button_main_online" style="margin-left:15px;"class="custom-file-upload w3-bar-item w3-button">Обновить</button> 
</div>

<br />
<label for="file-upload-second-core" class="custom-file-upload w3-bar-item w3-button">
  <i class="fa fa-cloud-upload"></i>Выбрать файл прошивки
</label>
<input id="file-upload-second-core" type="file" />
<button onclick="sendMODEM()" style="display:none" id="button_second_core_burn" class="w3-border w3-border-orange w3-btn w3-white">
  Перепрошить
</button>
</div>  
<div id="tab_updateSoft_PK4_url" class="w3-code border_red">            
</div>

<div class='tab_idDev_updateSoft' style="display:none; color: white;"><h3>Состояние прибора <span id="status_idDev_updateSoft"></span></h3></div>


<div class="w3-code border_blue status_modem_tr">
<b>Обновление конфигуратора </b><br />
 <br />
<div style="
display: flex;
justify-content: space-between;
">
 
  <div id="satus_new_version_config" style="display:none;position: relative;">
  Доступна версия конфигуратора<i class="numberCircleConfig">1</i></i>  <span id="number_new_ver_config" style="margin-left: 20px;"></span><button  onclick="uploadNewConfigurator()" id="button_main_online" style="margin-left:15px;"class="custom-file-upload w3-bar-item w3-button">Скачать</button> 
</div>

<div> <button  onclick="autoCheckNewConfig()" id="button_main_online" class="custom-file-upload w3-bar-item w3-button">Проверить обновления</button></div>
   </div>
  </div>
 </div>
</div>

         

        
       

        <!-- Обновление ПО ПК4-->
        <div id="tab_updateSoft_PK4" class="w3-container tab_content">          
        <div  id="tab_updateSoft_PK4_url" class="w3-code border_red">            
        </div>
        <div style="display:none" id="tab_updateSoft_PK4_check" class="w3-code border_red">            
        </div>
        </div>
        </div>
        <!-- IP/UDP -->
        <div id="tab_ip" class="w3-container tab_content"></div>

        <!-- GPRS -->
        <div id="tab_gprs" class="w3-container tab_content"></div>

      
        <!-- РАСШИРЕНИЯ -->
        <div id="tab_other" class="w3-container tab_content"></div>

        <!-- Development -->
        <div id="tab_development" class="w3-container tab_content">
          <table style="padding-bottom: 100px">
            <tr>
              <td><b>Отправка query запроса на сервер:</b></td>
              <td></td>
            </tr>
            <tr>
              <td>
                <label>Запрос: <input id="url_query"/></label><button onclick="query_test()">Отправить</button>
              </td>
              <td>Ответ:<span id="discription_query"></span></td>
            </tr>
            <tr>
              <td><br /><b>Отправка данных запроса на сервер(post запрос):</b></td>
              <td></td>
            </tr>
            <tr>
              <td><label></label><button onclick="post_test()">Отправить</button></td>
              <td></td>
            </tr>
            <tr>
              <td>
                <label id="statusTelLabel">Телеметрия включена</label><button class="w3-btn w3-red" onclick="stop_updateTelemetriya()">Выключить</button
                ><button class="w3-btn w3-green" onclick="start_updateTelemetriya()">Включить</button>
              </td>
              <td></td>
            </tr>

            <tr>
              <td><button class="w3-btn w3-green" onclick="testParserUart()">Тест парсера</button></td>
              <td></td>
            </tr>
            <tr>
              <td>
                <div><button onclick="downloadTxt()">Скачать конфигурационный файл</button></div>
              </td>
              <td></td>
            </tr>
            <tr>
              <td colspan="2"><h2>Браузер</h2></td>
            </tr>
            <tr>
              <td colspan="2"><button onclick='$.show(".w3_bar_alltabs")'>Отобразить все пункты меню</button></td>
            </tr>
            <tr>
              <td><div id="usrAgnt"></div></td>
              <td>
                <script>
                  document.getElementById("usrAgnt").innerHTML = navigator.userAgent;
                </script>
              </td>
            </tr>        
            <tr>
              <td>
                <div><button onclick="getUsbDevice()">USB-устройства</button></div>
              </td>
              <td><div id='usbDeviceList'></div></td>
            </tr>  
          </table>
        </div>

        <!-- Модальное окно авторизации -->
        <div id="modal_authentication" class="w3-modal">
          <form onsubmit="authenticationDevice(this);return false;">
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="document.getElementById('modal_authentication').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
                <h2>Авторизация</h2>
              </header>
              <div class="w3-container">
                <br />
                <label
                  >Пароль доступа к конфигурации <input type="password" autocomplete="off" required pattern="^[ 0-9]+$" id="modal_authentication_pass"
                /></label>
              </div>
              <footer class="w3-container" style="padding-bottom:4px">
                <div style="float:right">
                  <button
                    type="button"
                    class="w3-bar-item w3-button w3-red w3-round"
                    onclick="document.getElementById('modal_authentication').style.display='none'"
                  >
                    Отмена
                  </button>
                  <button class="w3-bar-item w3-button w3-teal w3-round" type="submit">OK</button> <br />
                </div>
              </footer>
            </div>
          </form>
        </div>

        <!-- Модальное окно Подключения -->
        <div id="modal_connect" class="w3-modal" style="display:none">
          <form onsubmit="connectDevice(this);return false;">
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="document.getElementById('modal_connect').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
                <h2>Подключение</h2>
              </header>
              <div class="w3-container modal_connect_blockPort" style="display:none;">
                <br />
                Порт для подключения:
                <select onchange="selectedCom_port(this)" id="modal_connect_port" class="w3-padding-small"></select>
              </div>
              <div class="w3-container modal_connect_blockNoDevice" style="display:none;">
                <br />
                Устройство не подключено
              </div>
              <footer class="w3-container" style="padding-bottom: 4px">
                <div style="float:right">
                  <button type="button" class="w3-bar-item w3-button w3-red w3-round btnConnect_сanсel" onclick="cancelConnectDevice()">Отмена</button>
                  <button type="submit" id="get_connect" class="w3-bar-item w3-button w3-teal w3-round btnConnect_ok">Подключить</button> <br />
                </div>
              </footer>
            </div>
          </form>
        </div>

        <!-- Модальное окно Создание новой конфигурации -->
        <div id="modal_new_config_mode" class="w3-modal" style="display:none">
          <form onsubmit="new_config_mod(this);return false;">
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="document.getElementById('modal_new_config_mode').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
                <h2>Web-приложение "Конфигуратор приборов"</h2>
              </header>
              <div class="w3-container"></div>
              <footer class="w3-container" style="padding-bottom: 4px">
                <div style="text-align: center; margin: 20px;">
                  <button
                    type="button"
                    class="w3-bar-item w3-button w3-teal w3-round btnConnect_сanсel"
                    style="margin-bottom: 5px; width:100%;"
                    onclick="startModConnect()"
                  >
                    Подключиться к прибору
                  </button>
                  <br />
                  <label
                    title="Открыть конфигурационный файл"
                    for="file-upload-one"
                    type="button"
                    style="width:100%;"
                    class="w3-bar-item w3-button w3-blue w3-round btnConnect_сanсel"
                  >
                    <i class="fa fa-cloud-upload"></i>Открыть конфигурацию
                  </label>
                  <input id="file-upload-one" type="file" /> <br />
                  <!--
                    button disabled style="margin-top: 5px; width:100%; cursor: disabled;" type="button" class="w3-bar-item w3-button w3-blue w3-round btnConnect_сanсel" onclick="">Создать конфигурацию</button
                  -->

                  <!-- button type="submit" id="get_connect" class="w3-bar-item w3-button w3-teal w3-round btnConnect_ok">Создать</button -->
                  
                  <button
                  type="button"
                  class="w3-bar-item tab_newDevice w3-button w3-grey w3-round btnConnect_сanсel"
                  style="margin-top: 5px; width:100%;"
                  onclick="createNewDevice()"
                >
                  Создать конфигурацию
                </button>

                  <!--button
                  type="button"
                  class="w3-bar-item tab_development w3-button w3-amber w3-round btnConnect_сanсel"
                  style="margin-top: 5px; width:100%; display:none;"
                  onclick="startDeveloperMode()"
                >
                  Режим разработчика
                </button-->
                  
                </div>
              </footer>
            </div>
          </form>
        </div>


        <!-- Модальное окно Записи конфигурации на USB -->
        <div id="modal_burn_to_usb" class="w3-modal" style="display:none">
          
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="document.getElementById('modal_burn_to_usb').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
                <h2>Выбор диска устройства</h2>
              </header>
              <div class="w3-container"></div>
              <footer class="w3-container" style="padding-bottom: 4px">
              <form onsubmit="burnSelectDevice(this);return false;">
                <div id='modal_burn_to_usb_box' style="text-align: center; margin: 20px;">
                      
                </div>
                <input id='btn_burnSelectDevice'
                disabled
                value='Записать на диск'
                class="w3-button w3-blue w3-block"
                style="margin-top: 5px;"
                onclick="burnSelectDevice()"
              >
                
              
              </form>
              </footer>
            </div>
          
        </div>

        <!-- Модальное окно Обновление ПО конфигурации на USB -->
        <div id="modal_update_to_usb" class="w3-modal" style="display:none">
          
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="document.getElementById('modal_update_to_usb').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
                <h2>Выбор диска устройства</h2>
              </header>
              <div class="w3-container"></div>
              <footer class="w3-container" style="padding-bottom: 4px">
              <form onsubmit="updatePOhandler(this);return false;">
                <div id='modal_update_to_usb_box' style="text-align: center; margin: 20px;">
                      
                </div>
                <input id='btn_UpdateSelectDevice'
                disabled
                value='Записать новую прошивку на диск'
                class="w3-button w3-blue w3-block"
                style="margin-top: 5px;"
                onclick="updatePOhandler()"
              >
                
              
              </form>
              </footer>
            </div>
          
        </div>
        <!-- Модальное окно список приборов -->
        <div id="modal_select_device" class="w3-modal">
         
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="document.getElementById('modal_select_device').style.display='none', $.modal('#modal_new_config_mode')" class="w3-button w3-display-topright">&#10006;</span>
                <h2>Выбор модели прибора</h2>
              </header>
              <div class="w3-container" style="height:600px">
              <h3>Группы приборов:</h3>
                <div style='height:90%; overflow-y:auto; overflow-x:hidden'>
                <table style="width:100%">                                
                <tr>
                  <td>
                  
                  </td>
                </tr>
                <tr>
                <td>
                <details style="display:none" onclick="closeAllDetails(thisindexDetails(this));" class='create_deviceList'>
                  <summary style='background:mediumaquamarine; padding-left:10px'></summary>
                      
                </details>                    
                <details onclick="closeAllDetails(thisindexDetails(this));" class='create_deviceList'>
                  <summary style='background:mediumaquamarine; padding-left:10px'>ППКОП "Юпитер 4GSM"</summary>
                      <button disabled class="list_btn">Юпитер-1429 (ППКОП "Юпитер 4GSM")</button>                        
                      <button disabled class="list_btn">Юпитер-1429v3 (ППКОП "Юпитер 4GSM v3")</button>                                              
                </details>                    
                </td>
              </tr>                
              <tr>
                <tr>
                  <td>
                  <details onclick="closeAllDetails(thisindexDetails(this));" class='create_deviceList'>
                    <summary style='background:mediumaquamarine; padding-left:10px'>Юпитер-1х3х/1х4х(ППКОП ЮПИТЕР IP/GPRS)</summary>
                        <button name="J1431" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-1431 (ППКОП ЮПИТЕР IP/GPRS 4)</button> 
                        <button name="J1433" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-1433 (ППКОП ЮПИТЕР IP/GPRS 4)</button>                       
                        <button name="J1831" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-1831 (ППКОП ЮПИТЕР IP/GPRS 8)</button>  
                        <button name="J1833" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-1833 (ППКОП ЮПИТЕР IP/GPRS 8)</button>                       
                         
                        <button name="J1931" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-1931 (ППКОП ЮПИТЕР IP/GPRS 16)</button> 
                        <button name="J1933" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-1933 (ППКОП ЮПИТЕР IP/GPRS 16)</button>                       
                        <button name="J1943" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-1943 (ППКОП ЮПИТЕР IP/GPRS 16)</button>    
                        <button name="J1431_GD" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-1431(GD) (ППКОП ЮПИТЕР IP/GPRS 4)</button>     
                        <button name="J1433_GD" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-1433(GD) (ППКОП ЮПИТЕР IP/GPRS 4)</button>   
                        <button name="J1831_GD" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-1831(GD) (ППКОП ЮПИТЕР IP/GPRS 8)</button>   
                        <button name="J1833_GD" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-1833(GD) (ППКОП ЮПИТЕР IP/GPRS 8)</button>  
                        <button name="J1931_GD" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-1931(GD) (ППКОП ЮПИТЕР IP/GPRS 16)</button>   
                        <button name="J1933_GD" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-1933(GD) (ППКОП ЮПИТЕР IP/GPRS 16)</button>  
                        <button name="J1943_GD" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-1943(GD) (ППКОП ЮПИТЕР IP/GPRS 16)</button>    
                                  
                        
                                
                  </details>                    
                  </td>
                </tr>                
                <tr>
                  <td>
                  <details onclick="closeAllDetails(thisindexDetails(this));" class='create_deviceList'>
                    <summary style='background:mediumaquamarine; padding-left:10px'>Юпитер-24хх (УОО ЮПИТЕР IP/GPRS)</summary>
                    
                    <button name="J2413" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2413 (УОО IP/GPRS (GPRS))</button>                        
                    <button name="J2443" onclick="sendCoreModelDevice(this)" id='clickJ2443' class="list_btn">Юпитер-2443 (УОО IP/GPRS (GPRS,Eth,RS485))</button>                        
                    <button name="J2444" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2444 (УОО IP/GPRS (GPRS,Eth,RS485,ЖКИ))</button>                        
                    
                    <button name="J2463" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2463 (УОО IP/GPRS (GPRS,Eth,WiFi,RS485))</button>                        
                    <button name="J2444E" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2444РШ (УОО IP/GPRS (GPRS,Eth,расш,ЖКИ))</button>                        
                    <button name="J2445" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2445 (УОО IP/GPRS (GPRS,Eth,расш))</button>                        
                    <button name="J2463E" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2463РШ (УОО IP/GPRS (GPRS,Eth,WiFi,расш))</button>  
                    <button name="J2413_2022" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2413(2022) (УОО IP/GPRS (GPRS))</button>   
                    <button name="J2443_2022" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2443(2022) (УОО IP/GPRS (GPRS))</button>  
                    <button name="J2463_2022" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2463(2022) (УОО IP/GPRS (GPRS))</button>  
                    <button name="J2444_2022" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2444(2022) (УОО IP/GPRS (GPRS))</button>  
                    <button name="J2445_2022" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2445(2022) (УОО IP/GPRS (GPRS))</button>                        
                  </details>
                  </td>
                </tr>                
                <tr>
                  <td>
                  <details onclick="closeAllDetails(thisindexDetails(this));" class='create_deviceList'>
                    <summary style='background:mediumaquamarine; padding-left:10px'>Юпитер-242х</summary>
                        <button name="J2420" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2420</button>                        
                        <button name="J2421" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2421</button>                                                
                        <button name="J2422" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2422</button>                                                
                        <button name="J2424" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2424</button>                                                
                        <button name="J2425" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2425</button>                                                
                        <button name="J2426" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2426</button>      
                        <button name="J2427" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2427</button>                                            
                        <button name="J2428" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2428</button>                                                
                        <button name="J2429" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2429</button>                                                
                        <button name="J2421_v2" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2421 v2</button> 
                        <button name="J2424_v2" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2424 v2</button> 
                        <button name="J2425_v2" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2425 v2</button>  
                        <button name="J2426_v2" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2426 v2</button>  
                         
                  </details>                    
                  </td>
                </tr>                
                <tr>
                  <td>
                  <details onclick="closeAllDetails(thisindexDetails(this));" class='create_deviceList'>
                    <summary style='background:mediumaquamarine; padding-left:10px'>Юпитер-232х</summary>
                        <button name="J2320" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2320</button>                        
                        <button name="J2321" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2321</button>                        
                        <button name="J2326" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2326</button>                                              
                  </details>                    
                  </td>
                </tr>
                <tr>
                  <td>
                  <details onclick="closeAllDetails(thisindexDetails(this));" class='create_deviceList'>
                    <summary style='background:mediumaquamarine; padding-left:10px'>Сатурн</summary>
                        <button name="S2413" onclick="sendCoreModelDevice(this)" class="list_btn">Сатурн-2413</button>                                                                                            
                        <button name="S2813" onclick="sendCoreModelDevice(this)" class="list_btn">Сатурн-2813</button>                        
                        <button name="S2814" onclick="sendCoreModelDevice(this)" class="list_btn">Сатурн-2814</button>                        
                        <button name="S2818" onclick="sendCoreModelDevice(this)" class="list_btn">Сатурн-2818</button>                        
                        <button name="S2819" onclick="sendCoreModelDevice(this)" class="list_btn">Сатурн-2819</button>                                                                     
                  </details>                    
                  </td>
                </tr>                 
                <tr>
                <td>
                <details onclick="closeAllDetails(thisindexDetails(this));" class='create_deviceList'>
                  <summary style='background:mediumaquamarine; padding-left:10px'>Радиоканальные</summary>                      

                  <button name="J2021N" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2021</button>                                                      
                  <button name="J2021" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2021(2018г.)</button>                                                      
                  <button name="J2028N" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2028</button>                                                      
                  <button name="J2028" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2028(2018г.)</button>                                                      
                  <button name="J2029N" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2029</button>                                                      
                  <button name="J2029" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2029(2018г.)</button>                                                      
                  <!--button name="S2081" onclick="sendCoreModelDevice(this)" class="list_btn">Сатурн-2081</button-->                        
                  <!--button name="S2082" onclick="sendCoreModelDevice(this)" class="list_btn">Сатурн-2082</button-->   
                  <!--button name="S2084" onclick="sendCoreModelDevice(this)" class="list_btn">Сатурн-2084</button-->                                                     
                  <button name="J2081" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2081</button>                                                      
                  <button name="J2082" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2082</button>                                                      
                  <button name="J2083" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2083</button>                                                      
                  <button name="J2084" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-2084</button>                                                      
                  <button name="S2081" onclick="sendCoreModelDevice(this)" class="list_btn">Сатурн-2081</button>                                                      
                  <button name="S2082" onclick="sendCoreModelDevice(this)" class="list_btn">Сатурн-2082</button>    
                  <button name="S2084" onclick="sendCoreModelDevice(this)" class="list_btn">Сатурн-2084</button>                                                   
                </details>                    
                </td>
              </tr>

              <tr>
                <td>
                <details onclick="closeAllDetails(thisindexDetails(this));" class='create_deviceList'>
                  <summary style='background:mediumaquamarine; padding-left:10px'>Тревожные кнопки</summary>                      

                  <button name="J6423" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-6423</button>  
                  <button name="J6422" onclick="sendCoreModelDevice(this)" class="list_btn">Юпитер-6422</button>                                                                                                            
                </details>                    
                </td>
              </tr>
                <tr>
                <td>
                
                </td>
              </tr>                
              <tr>               
                </table>
                </div>                
              </div>
              <footer class="w3-container" style="padding-bottom: 4px">
                <div style="float:right">
                  <button type="button" class="w3-bar-item w3-button w3-red w3-round" onclick="document.getElementById('modal_select_device').style.display='none', $.modal('#modal_new_config_mode')">
                   Назад
                  </button>                  
                </div>
              </footer>
            </div>
        
        </div>




        <!-- Модальное окно о конфигураторе -->
        <div id="modal_info_config" class="w3-modal">
          <form onsubmit="resetDevice(this);return false;">
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="document.getElementById('modal_info_config').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
                <h2>Информация о конфигураторе</h2>
              </header>
              <div class="w3-container">
                <br />
                <div>
                <table>                
                <tr><td><span>Поддерживаемые устройства:</span></td></tr>
                <tr><td><span style='padding-left:20px'><a target="_blank" href="https://www.prosaturn.ru/product-page/%D0%BA%D0%BE%D0%BD%D1%82%D1%80%D0%BE%D0%BB%D1%8C%D0%BD%D0%B0%D1%8F-%D0%BF%D0%B0%D0%BD%D0%B5%D0%BB%D1%8C-%D1%81%D0%B0%D1%82%D1%83%D1%80%D0%BD-2413">Сатурн-2413</a></span></td></tr>
                <tr><td><span style='padding-left:20px'><a target="_blank" href="https://www.prosaturn.ru/product-page/%D0%BA%D0%BE%D0%BD%D1%82%D1%80%D0%BE%D0%BB%D1%8C%D0%BD%D0%B0%D1%8F-%D0%BF%D0%B0%D0%BD%D0%B5%D0%BB%D1%8C-%D1%81%D0%B0%D1%82%D1%83%D1%80%D0%BD-2813">Сатурн-2813</a></span></td></tr>
                <tr><td><span style='padding-left:20px'><a target="_blank" href="https://www.prosaturn.ru/product-page/%D0%BA%D0%BE%D0%BD%D1%82%D1%80%D0%BE%D0%BB%D1%8C%D0%BD%D0%B0%D1%8F-%D0%BF%D0%B0%D0%BD%D0%B5%D0%BB%D1%8C-%D1%81%D0%B0%D1%82%D1%83%D1%80%D0%BD-2428">Сатурн-2818</a></span></td></tr>
                <tr><td><span style='padding-left:20px'><a target="_blank" href="https://www.prosaturn.ru/product-page/%D0%BA%D0%BE%D0%BD%D1%82%D1%80%D0%BE%D0%BB%D1%8C%D0%BD%D0%B0%D1%8F-%D0%BF%D0%B0%D0%BD%D0%B5%D0%BB%D1%8C-%D0%B2-%D0%BA%D0%BE%D1%80%D0%BF%D1%83%D1%81%D0%B5-%D1%80%D0%B1%D0%BF-%D1%81%D0%B0%D1%82%D1%83%D1%80%D0%BD-2819">Сатурн-2819</a></span></td></tr>
                <tr><td><span style='padding-left:20px'>Юпитер-2081</span></td></tr>
                <tr><td><span style='padding-left:20px'>Юпитер-2082</span></td></tr>
                <tr><td><span style='padding-left:20px'>Юпитер-2083</span></td></tr>
                <tr><td><span style='padding-left:20px'>Юпитер-2084</span></td></tr>                
                </table>
                </div>                
              </div>
              <footer class="w3-container" style="padding-bottom: 4px">
                <div style="float:right">
                  <button type="button" class="w3-bar-item w3-button w3-red w3-round" onclick="document.getElementById('modal_info_config').style.display='none'">
                  &#10008; Закрыть
                  </button>                  
                </div>
              </footer>
            </div>
          </form>
        </div>

        <!-- Модальное окно ошибки ядра -->
        <div id="modal_error_core" class="w3-modal">
          <form onsubmit="resetDevice(this);return false;">
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-red">
                <!--span onclick="document.getElementById('modal_error_core').style.display='none'" class="w3-button w3-display-topright">&#10006;</span-->
                <h2>Ошибка</h2>
              </header>
              <div class="w3-container">
                <br />
                <div>
                  <div id='modal_error_text'>
                  </div>


                </div>                
              </div>
              <footer class="w3-container" style="padding-bottom: 4px">
                <div style="float:right">
                  <button type="button" class="w3-bar-item w3-button w3-red w3-round" onclick="document.getElementById('modal_error_core').style.display='none'">
                  &#10008; Закрыть
                  </button>                  
                </div>
              </footer>
            </div>
          </form>
        </div>

          <!-- Модальное окно депассивации -->
        <div id="modal_depassivation" class="w3-modal">
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-blue">
                
                <h2>Подготовка к программированию устройства</h2>
              </header>
              <div class="w3-container">
                <br />
                <div>
                  <div id='modal_depassivation_text'>
                  Проведите депассивацию батареи "ER14250" и нажмите "Продолжить"
                  </div>


                </div>                
              </div>
              <footer class="w3-container" style="padding-bottom: 4px">
                <div style="float:right">
                  <button type="button" class="w3-bar-item w3-button w3-border w3-round" onclick="document.getElementById('modal_depassivation').style.display='none'">
                   Отмена
                  </button>                  
                  <button type="button" onclick="program_mod_xxpg()" id='depassivation_btn' class="w3-bar-item w3-button w3-blue w3-round">
                   Продолжить
                  </button>                  
                </div>
              </footer>
            </div>
        </div>

        <!-- Модальное окно Перезапуск -->
        <div id="modal_reset" class="w3-modal">
          <form onsubmit="resetDevice(this);return false;">
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="document.getElementById('modal_reset').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
                <h2>Перезапуск</h2>
              </header>
              <div class="w3-container">
                <br />
                Вы действительно хотите перезапустить прибор ?
              </div>
              <footer class="w3-container" style="padding-bottom: 4px">
                <div style="float:right">
                  <button type="button" class="w3-bar-item w3-button w3-red w3-round" onclick="document.getElementById('modal_reset').style.display='none'">
                    НЕТ
                  </button>
                  <button class="w3-bar-item w3-button w3-teal w3-round" type="submit">ДА</button> <br />
                </div>
              </footer>
            </div>
          </form>
        </div>

        <!-- Модальное окно Карточка радиоканального устройства -->
        <div id="modal_r_device" class="w3-modal">
          
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="closeModalR_dev()" class="w3-btn-close w3-hover-shadow w3-display-topright">&#10006;</span>
                <h2 id="modal_r_device_title"></h2>
              </header>
              <div class="w3-container">                
                <div style="padding-top:10px" id="modal_r_device_body"></div>
              </div>
              <footer id='modal_radio_footer' class="w3-container" style="padding-bottom: 4px">
             
                <div style="float:right">
                <label id="errorAddDevice"></label>
                  <button id='modal_r_device_delete' type="button" class="w3-bar-item w3-button w3-red w3-round" onclick="saveModalRadio_REMOVE()">
                  &#9851; Удалить
                </button>
                  <button type="button" class="w3-bar-item w3-button w3-orange w3-round" onclick="closeModalR_dev()">
                  &#10008; Закрыть
                  </button>
                  <button id='modal_integral_save' onclick='saveRS4_Modal_extendersExe()' class="w3-bar-item w3-button w3-teal w3-round">&#10004; Сохранить</button>
                  <button id='modal_r_device_save' onclick='saveModalRadio()' class="w3-bar-item w3-button w3-teal w3-round">&#10004; Сохранить</button>
                  <button id='modal_r_exe_save' onclick='saveModalRadioEXT_NEW()' class="w3-bar-item w3-button w3-teal w3-round">&#10004; Сохранить</button> <br />
                </div>
              </footer>
            </div>
          </form>
        </div>  

        <!-- Модальное окно Карточка РАСШИРИТЕЛЯ -->
        <div id="modal_ext_card" class="w3-modal">
          
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="close_Modal_extenders()" class="w3-btn-close w3-hover-shadow w3-display-topright">&#10006;</span>
                <h2 id="modal_ext_title"></h2>
              </header>
              <div class="w3-container">                
                <div style="padding-top:10px" id="modal_ext_body"></div>
              </div>
              <footer id='modal_extenders_footer' class="w3-container" style="padding-bottom: 4px; display:none;">
                
              </footer>
            </div>
          </form>
        </div> 


        <!-- Модальное окно ОКОНЧАНИЕ/ПЕРЕЗАГРУЗКА прибора по окончании конфигурации -->
        <div id="modal_reset_save" class="w3-modal">
          <form>
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="document.getElementById('modal_reset_save').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
                <h2> Конфигуратор</h2>
              </header>
              <div class="w3-container">
                <br />
                 После завершения конфигурации рекомендуется перезагрузить прибор </br>
              </div>
              <footer class="w3-container" style="padding-bottom: 4px">
                <div style="float:right">
                  <button type="button" onclick="document.getElementById('modal_reset_save').style.display='none'" id="modal_reset_reboot_later" class="w3-bar-item w3-button w3-red w3-round">
                    Продолжить
                  </button>
                  <button type="button" onclick="resetDevice()" class="w3-bar-item w3-button w3-teal w3-round")">Перезагрузить</button> <br />
                </div>
              </footer>
            </div>
          </form>
        </div>

        <!-- Модальное окно Успешного сохранения  прибора по окончании конфигурации -->
        <div id="modal_compected_save" class="w3-modal">
          <form>
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="document.getElementById('modal_compected_save').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
                <h2> Конфигуратор</h2>
              </header>
              <div class="w3-container">
                <br />
                 Конфигурация успешно сохранена
              </div>
              <footer class="w3-container" style="padding-bottom: 4px">
                <div style="float:right">                  
                  <button type="button" onclick="document.getElementById('modal_compected_save').style.display='none'" class="w3-bar-item w3-button w3-teal w3-round")">ОК</button> <br />
                </div>
              </footer>
            </div>
          </form>
        </div>
        <!-- Модальное окно Успешного сохранения нового ПО и необходимости отключить безопасно USB и перезапустить прибор -->
        <div id="modal_compected_save_update" class="w3-modal">
          <form>
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="document.getElementById('modal_compected_save_update').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
                <h2> Обновление сохранено в прибор.</h2>
              </header>
              <div class="w3-container">
                <br />
                 Необходимости отключить безопасно USB и перезапустить прибор.
              </div>
              <footer class="w3-container" style="padding-bottom: 4px">
                <div style="float:right">                  
                  <button type="button" onclick="document.getElementById('modal_compected_save_update').style.display='none'" class="w3-bar-item w3-button w3-teal w3-round")">ОК</button> <br />
                </div>
              </footer>
            </div>
          </form>
        </div>

        <!-- Модальное окно Блокрировки конфигуратора в случае запущенного удаленного конфигуратора -->
        <div id="modal_lockTuner" class="w3-modal">
          <form>
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="document.getElementById('modal_lockTuner').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
                <h2> Конфигуратор заблокирован</h2>
              </header>
              <div class="w3-container">
                <br />
                 Конфигурирование прибора невозможно! <br />
                 В данный момент прибор на связи с удаленным конфигуратором. 
              </div>
              <footer class="w3-container" style="padding-bottom: 4px">
                <div style="float:right">                  
                  <button type="button" onclick="document.getElementById('modal_lockTuner').style.display='none'" class="w3-bar-item w3-button w3-teal w3-round")">ОК</button> <br />
                </div>
              </footer>
            </div>
          </form>
        </div>

        <!-- Модальное окно Из прибора -->
        <div id="modal_read_conf" class="w3-modal">
          <form onsubmit="getDevice_conf(this);return false;">
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="document.getElementById('modal_read_conf').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
                <h2>Загрузка конфигурации</h2>
              </header>
              <div class="w3-container">
                <br />
                Загрузить конфигурацию из прибора ?
              </div>
              <footer class="w3-container" style="padding-bottom: 4px">
                <div style="float:right">
                  <button type="button" class="w3-bar-item w3-button w3-red w3-round" onclick="document.getElementById('modal_read_conf').style.display='none'">
                    НЕТ
                  </button>
                  <button class="w3-bar-item w3-button w3-teal w3-round" type="submit">ДА</button> <br />
                </div>
              </footer>
            </div>
          </form>
        </div>


        <!-- Модальное окно Автоматическое обновление ПО -->
        <div style="margin-top:50px" id="modal_auto_updateSoft" class="w3-modal">
          <form onsubmit="getUpdateDevice('main');return false;">
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="document.getElementById('modal_auto_updateSoft').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
                <h2>Обновление ПО</h2>
              </header>
              <div class="w3-container">
                <br />
                <div id="text_updateSoft"></div>
              
              
              </div>
              <footer class="w3-container" style="padding-bottom: 4px;   ">
                <div style="float:right">
                  <button type="button" class="w3-bar-item w3-button w3-red w3-round" onclick="document.getElementById('modal_auto_updateSoft').style.display='none'">
                    Отмена
                  </button>
                  <button id="update_btn"  class="w3-bar-item w3-button w3-teal w3-round " type="submit">Обновить</button> <br />
                </div>
              </footer>
            </div>
          </form>
        </div>

        <!-- Модальное окно Автоматическое обновление вспомогательное ядро -->
        <div style="margin-top:400px" id="modal_auto_updateSoft_secondCore" class="w3-modal">
          <form onsubmit="getUpdateDevice('second');return false;">
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="document.getElementById('modal_auto_updateSoft_secondCore').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
                <h2>Обновление вспомогательного ядра</h2>
              </header>
              <div class="w3-container">
                <br />
                <div id="text_updateSoft_secondCore"></div>
              
              
              </div>
              <footer class="w3-container" style="padding-bottom: 4px; visibility: hidden;">
                <div style="float:right">
                  <button type="button" class="w3-bar-item w3-button w3-red w3-round" onclick="document.getElementById('modal_auto_updateSoft_secondCore').style.display='none'">
                    Отмена
                  </button>
                  <button id="update_btn_secondCore"  class="w3-bar-item w3-button w3-teal w3-round " type="submit">Обновить</button> <br />
                </div>
              </footer>
            </div>
          </form>
        </div>

        <!-- Модальное окно Подготовка обновление ПО -->
        <div style="margin-top:50px" id="modal_auto_updateSoft_zip" class="w3-modal">
          <form onsubmit="updatePOhandler();return false;">
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="document.getElementById('modal_auto_updateSoft_zip').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
                <h2>Подготовка к обновлению ПО </h2>
              </header>
              <div class="w3-container">
                <br />
                <div id="text_updateSoft_zip">Начать процесс обновления ПО?</div>
                <div  id="text_updateSoft_versions"></div>
              
              </div>
              <footer class="w3-container" style="padding-bottom: 4px">
                <div style="float:right">
                  <button type="button" class="w3-bar-item w3-button w3-red w3-round" onclick="document.getElementById('modal_auto_updateSoft_zip').style.display='none'">
                    Нет
                  </button>
                  <button id="block_upload" class="w3-bar-item w3-button w3-teal w3-round " type="submit">Да</button> <br />
                </div>
              </footer>
            </div>
          </form>
        </div>
        <!--Ошибка! Модальное окно Автоматическое обновление ПО -->
        <div id="error_modal_auto_updateSoft" class="w3-modal">
          <form onsubmit="getUpdateDevice(this);return false;">
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="document.getElementById('error_modal_auto_updateSoft').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
                <h2>Обновление ПО</h2>
              </header>
              <div class="w3-container">
                <br />
                Ошибка загрузки, неверный crc!
              </div>
              <footer class="w3-container" style="padding-bottom: 4px; visibility: hidden;">
                <div style="float:right">
                  <button type="button" class="w3-bar-item w3-button w3-red w3-round" onclick="document.getElementById('error_modal_auto_updateSoft').style.display='none'">
                    Закрыть
                  </button>
                   <br />
                </div>
              </footer>
            </div>
          </form>
        </div>

        <!-- Модальное окно Автоматическое обновление конфигуратора -->
        <div style="margin-top:50px" id="modal_auto_updateConfig" class="w3-modal">
          <form onsubmit="uploadNewConfigurator();return false;">
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="document.getElementById('modal_auto_updateConfig').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
                <h2>Обновление Конфигуратора</h2>
              </header>
              <div class="w3-container">
                <br />
                <div id="text_updateConfig"></div>
              
              
              </div>
              <footer class="w3-container" style="padding-bottom: 4px;">
                <div style="float:right">
                  <button type="button" class="w3-bar-item w3-button w3-red w3-round" onclick="document.getElementById('modal_auto_updateConfig').style.display='none'">
                    Отмена
                  </button>
                  <button id="updateConfig_btn"  class="w3-bar-item w3-button w3-teal w3-round " type="submit">Скачать</button> <br />
                </div>
              </footer>
            </div>
          </form>
        </div>

        <!-- Модальное удаление ключа -->
        <div id="modal_remove_key" class="w3-modal">
          <form id="modal_remove_key_form">
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="document.getElementById('modal_remove_key').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
                <h2>Удаление ключа № <span id="removeKeyTitle"></span></h2>
              </header>
              <div class="w3-container">
                <br />
                Вы действительно хотите удалить ключ
              </div>
              <footer class="w3-container" style="padding-bottom: 4px">
                <div style="float:right">
                  <button
                    type="button"
                    class="w3-bar-item w3-button w3-red w3-round"
                    onclick="document.getElementById('modal_remove_key').style.display='none'"
                  >
                    НЕТ
                  </button>
                  <button class="w3-bar-item w3-button w3-teal w3-round" type="submit">ДА</button> <br />
                </div>
              </footer>
            </div>
          </form>
        </div>

        <!-- Модальное окно Запись конфигурации в прибор -->
        <div id="modal_conf_toDev" class="w3-modal">
          <form onsubmit="configToDevice();return false;">
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="document.getElementById('modal_conf_toDev').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
                <h2>Запись конфигурации</h2>
              </header>
              <div class="w3-container">
                <br />
                Записать конфигурацию в прибор?
              </div>
              <footer class="w3-container" style="padding-bottom: 4px">
                <div style="float:right">
                  <button
                    type="button"
                    class="w3-bar-item w3-button w3-red w3-round"
                    onclick="document.getElementById('modal_conf_toDev').style.display='none'"
                  >
                    НЕТ
                  </button>
                  <button class="w3-bar-item w3-button w3-teal w3-round" type="submit">ДА</button> <br />
                </div>
              </footer>
            </div>
          </form>
        </div>

        <!-- Модальное окно подключение и сохранение XXAD -->
        <div id="modal_no_connect_XXAD" class="w3-modal">
          <form onsubmit="configToDevice_connectXXAD();return false;">
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="document.getElementById('modal_no_connect_XXAD').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
                <h2>Подключение радиоканального датчика <span id='modal_no_connect_XXAD_number'></span></h2>
              </header>
              <div class="w3-container">
                <br />
                Для подключения устройства сначала запишите конфигурацию в прибор и повторите попытку.
                <br />
                <br />
              </div>
              <footer class="w3-container" style="padding-bottom: 4px">
                <div style="float:right">
                  <button
                    type="button"
                    class="w3-bar-item w3-button w3-red w3-round"
                    onclick="document.getElementById('modal_no_connect_XXAD').style.display='none'"
                  >
                    Отмена
                  </button>
                  <button class="w3-bar-item w3-button w3-teal w3-round" type="submit">Записать</button> <br />
                </div>
              </footer>
            </div>
          </form>
        </div>


        <!-- Модальное окно ошибки сохранения конфигурации -->
        <div id="modal_error_save" class="w3-modal">
          <form>
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="document.getElementById('modal_error_save').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
                <h2>Заблокировано изменение настроек</h2>
              </header>
              <div class="w3-container">                
              <br />
                Прибор находится во взятом состоянии, редактирование параметров невозможно.
                Для изменения параметров работы прибора необходимо снять его с охраны.
                <br />
                <br />
                
              </div>
              <footer class="w3-container" style="padding-bottom: 4px">
                <div style="float:right">
                <button type="button" title="Сохранить текущую конфигурацию в файл" onclick="configIniSave()" class="w3-bar-item w3-blue w3-button">Сохранить конфигурацию в файл</button>
                  <button
                    type="button"
                    class="w3-bar-item w3-button w3-green w3-round"
                    onclick="document.getElementById('modal_error_save').style.display='none'"
                  >
                    Продолжить
                  </button>
                  
                </div>
              </footer>
            </div>
          </form>
        </div>

        <!-- Модальное окно ошибки проверки корретности ключей для приборов -->
        <div id="modal_error_device_key" class="w3-modal">
          <form>
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-red">
                <span onclick="closeErrorModalDeviceKeys()" class="w3-button w3-display-topright">&#10006;</span>
                <h2>Некорретно заполнено поле:</h2>
              </header>
              <div class="w3-container">                
              <br />
                <ul style="margin:0px" class="error_device_key_text"></ul>
                <br />
                <br />
                
              </div>
              <footer class="w3-container" style="padding-bottom: 4px">
                <div style="float:right">
           
                  <button
                    type="button"
                    class="w3-bar-item w3-button w3-red w3-round"
                    onclick="closeErrorModalDeviceKeys()"
                  >
                    Закрыть
                  </button>
                  
                </div>
              </footer>
            </div>
          </form>
        </div>


        <!-- Модальное окно ошибки сохранения конфигурации -->
        <div id="modal_save_hard" class="w3-modal">
          <form>
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="document.getElementById('modal_save_hard').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
                <h2>Записать конфигурацию в прибор</h2>
              </header>
              <div class="w3-container">                
              <br />
               Имеются несохраненная конфигурация. Перед добавлением нового расширителя необходимо записать конфигурацию в прибор.
                <br />
                <br />
                
              </div>
              <footer class="w3-container" style="padding-bottom: 4px">
                <div style="float:right">
                <button type="button" title="Сохранить текущую конфигурацию в файл" onclick="document.getElementById('modal_save_hard').style.display='none'" class="w3-bar-item w3-blue w3-button">Отмена</button>
                  <button
                    type="button"
                    class="w3-bar-item w3-button w3-green w3-round"
                    onclick="configToDevice(); document.getElementById('modal_save_hard').style.display='none'"
                  >
                    Записать конфигурацию в прибор
                  </button>
                  
                </div>
              </footer>
            </div>
          </form>
        </div>

        <!-- Модальное окно ошибки сохранения конфигурации -->
        <div id="modal_error_unlock_gprs" class="w3-modal">
          <form>
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="document.getElementById('modal_error_unlock_gprs').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
                <h2>Ошибка</h2>
              </header>
              <div class="w3-container">                
              <br />
                Введен неверный пароль.
                
              </div>
              <footer class="w3-container" style="padding-bottom: 4px">
                <div style="float:right">
                
                  <button
                    type="button"
                    class="w3-bar-item w3-button w3-red w3-round"
                    onclick="document.getElementById('modal_error_unlock_gprs').style.display='none'"
                  >
                    ок
                  </button>
                  
                </div>
              </footer>
            </div>
          </form>
        </div>

        <!-- Модальное окно Выхода из конфигуратора -->
        <div id="modal_exitTuner" class="w3-modal">
          <form onsubmit="exitTunerGet(true);return false;">
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="document.getElementById('modal_exitTuner').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
                <h2>Выход</h2>
              </header>
              <div class="w3-container">
                <br />
                Вы хотите записать изменения в прибор?
              </div>
              <footer class="w3-container" style="padding-bottom: 4px">
                <div style="float:right">
                <button
                type="button"
                class="w3-bar-item w3-button w3-red w3-round"
                onclick="exitTunerGet(false)"
                >
                Нет
                </button>
                <button type="submit" class="w3-bar-item w3-button w3-teal w3-round">Да</button>
                  <br />
                </div>
              </footer>
            </div>
          </form>
        </div>
        <!-- конец -->
        <!-- Модальное окно отключение прибора -->
        <div id="modal_disconnectTuner" class="w3-modal">
          <form onsubmit="disconnectDevice('-1');return false;">
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="document.getElementById('modal_disconnectTuner').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
                <h2>Отключить</h2>
              </header>
              <div class="w3-container">
                <br />
                Имеются не сохраненные данные. Вы хотите отключить прибор?
              </div>
              <footer class="w3-container" style="padding-bottom: 4px">
                <div style="float:right">
                <button
                type="button"
                class="w3-bar-item w3-button w3-red w3-round"
                  onclick="document.getElementById('modal_disconnectTuner').style.display='none'" 
                >
                Нет
                </button>
                <button type="submit" class="w3-bar-item w3-button w3-teal w3-round">Да</button>
                  <br />
                </div>
              </footer>
            </div>
          </form>
        </div>
        <!-- конец -->

        <!-- Модальное окно Ожидания ответа сервера -->
        <div id="modal_continue" class="w3-modal" style="display:none">
          <form onsubmit="">
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-red">
                <span onclick="document.getElementById('modal_continue').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
                <h2 id="modal_continue_title">Ожидание</h2>
              </header>
              <div class="w3-container" id="modal_continue_body"></div>
              <footer class="w3-container" style="padding-bottom: 4px">
                <div style="float:right" id="modal_continue_footer">
                  <button id='modal_continue_btn_ok' type="button" class="w3-bar-item w3-button w3-card-4" onclick="document.getElementById('modal_continue').style.display='none';document.getElementById('modal_authentication_pass').focus()">
                    OK
                  </button>
                  <br />
                </div>
              </footer>
            </div>
          </form>
        </div>
        <!-- конец -->

        <!-- Модальное окно калибровки ШС -->
        <div id="modal_calibration" class="w3-modal">
          <form onsubmit="">
            <div class="w3-modal-content w3-animate-top w3-card-4">
              <header class="w3-container w3-teal">
                <span onclick="document.getElementById('modal_calibration').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
                <h2>Калибровка</h2>
              </header>
              <div class="w3-container">
                <br />
                Настройка сопротивления для <span id="calibrationSection"></span> шлейфа сигнализации <br /><br />
              </div>
              <footer class="w3-container" style="padding-bottom: 4px">
                <div style="float:right" id="calibrationSection_controls">
                  <button id="calibrationBtnAuto" onclick="getColibration(this)" type="button" class="w3-bar-item w3-button w3-teal w3-round">
                    Автоматически
                  </button>
                  <button id="calibrationBtnNorm" onclick="getColibration(this)" type="button" class="w3-bar-item w3-button w3-teal w3-round">
                    Установить сопротивление норма = 3кОм
                  </button>
                  <button
                    type="button"
                    class="w3-bar-item w3-button w3-red w3-round"
                    onclick="document.getElementById('modal_calibration').style.display='none'"
                  >
                    Отмена
                  </button>
                  <br />
                </div>
              </footer>
            </div>
          </form>
        </div>
        <!-- конец -->

        <!-- Модальное окно Добавления КЛЮЧА -->
        <div id="modal_addKey" class="w3-modal">
          <div class="w3-modal-content w3-animate-top w3-card-4">
            <header class="w3-container w3-teal">
              <span onclick="document.getElementById('modal_addKey').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
              <h2><span id="titleModalkey">Добавление нового ключа</span></h2>
            </header>
            <div class="w3-container">
              <form oninput="validationСheckUa(this);return false;">
                <table>
                  <tr>
                    <td>Номер кода пользователя</td>
                    <td>
                      <input type="number" min="1" max="250" required id="newKeyNumber" style="width:100px" /><span id="helpKeyNumber" style="color:red"></span>
                    </td>
                  </tr>
                  <tr>
                    <td>Код управления</td>
                    <td>
                      <input class="newKeyLock" id="newKeyCode" required pattern="[0-9]{3}" style="width:200px" /><span
                        style="color:red"
                        id="helpKeyNumber2"
                      ></span>
                    </td>
                  </tr>
                  <tr>
                    <td>Режим работы</td>
                    <td>
                      <select onchange="setTypeKeyMod(this)" class="newKeyLock" id="newKeyMode" style="width:200px">                      
                      </select>
                    </td>
                    <td class="newKeyLock NotUseAnAlias">Псевдоним</td>
                    <td>
                      <input class="newKeyLock NotUseAnAlias" id="newKeyNickName" name='ua' style="width:100px"/>                      
                    </td>
                  </tr>
                </table>
              </form>
              <div id="contentTypeKeyMod">
                <table>
                  <tr>
                    <td>Привязка к</td>
                    <td>
                      <div id="newKeyBlockSections" style="margin-top: 26px;"></div>
                      <br />
                    </td>
                  </tr>
                </table>              
              </div>
              
            </div>
            <footer class="w3-container" style="padding-bottom:4px">
              <div style="float:right">
                <button class="w3-bar-item w3-button w3-red w3-round" onclick="document.getElementById('modal_addKey').style.display='none'">Отмена</button>
                <button class="w3-bar-item w3-button w3-teal w3-round newKeyLockSave" onclick="saveEditKey()">&#10004; Сохранить</button> <br />
              </div>
            </footer>
          </div>
        </div>
        <!-- конец -->

        <!-- Модальное окно Разблокировки GSM -->
        <div id="modal_configGsm" class="w3-modal">
          <div class="w3-modal-content w3-animate-top w3-card-4">
            <header class="w3-container w3-teal">
              <span onclick="document.getElementById('modal_configGsm').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
              <h2>Разблокировка настроек IP/UDP</h2>
            </header>
            <div class="w3-container">
              <br />
              В целях безопасности необходимо ввести пароль разблокировки настроек IP/UDP <input id="passUnlockServer" style="width:200px; border-color: black;" /> <br/>
              <span style="color:blue;">Пароль доступен администратору сервера КРОС. Он находится в карточке прибора на вкладке "Основные" в поле "Пароль".</span>
              <img src="images/passKroc.png" width="880" height="320" alt="карточка прибора ">

            </div>
            <div class="w3-container identifier"></div>
            <div class="w3-container password"></div>   
             
            <footer class="w3-container" style="padding-bottom: 4px">
              <div style="float:right">
                <button class="w3-bar-item w3-button w3-red w3-round" onclick="document.getElementById('modal_configGsm').style.display='none'">Отмена</button>
                <button class="w3-bar-item w3-button w3-teal w3-round" onclick="unlockGsmConfig()">Разблокировать</button> <br />
              </div>
            </footer>
          </div>
        </div>
        <!-- конец -->

        <!-- Модальное окно ДОВНЛОАД -->
        <div id="modal_download_conff" class="w3-modal">
          <div class="w3-modal-content w3-animate-top w3-card-4">
            <header class="w3-container w3-teal">
              <span onclick="document.getElementById('modal_download_conff').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
              <h2>Сохранение конфигурационного файла</h2>
            </header>
            <div class="w3-container"></div>
            <footer class="w3-container" style="padding-bottom: 4px">
              <div id="modal_download_conff_btn" style="float:right">
                <button class="w3-bar-item w3-button w3-red w3-round" onclick="document.getElementById('modal_download_conff').style.display='none'">
                  Отмена
                </button>
                <button class="w3-bar-item w3-button w3-teal w3-round" onclick="unlockGsmConfig()">Разблокировать</button> <br />
              </div>
            </footer>
          </div>
        </div>
        <!-- конец -->

        <!-- Модальное окно ДОВНЛОАД -->
        <div id="modal_loader" class="w3-modal">
        <div id="loading-container">
  <div class="loader-div">
    <div class="loader-div">
      <div class="loader-div">
        <div class="loader-div">
          <div class="loader-div">
            <div class="loader-div">
              <div class="loader-div">
              <div class="loader-div-reload"></div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>
        </div>
        <!-- конец -->

        <!-- Модальное окно Сохранение логов -->
        <div id="modal_save_log" class="w3-modal">
          <div class="w3-modal-content w3-animate-top w3-card-4">
            <header class="w3-container w3-teal">
              <span onclick="document.getElementById('modal_save_log').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
              <h2>Сохранение логов из прибора</h2>
            </header>
            <div class="w3-container">
              <br />
              Название файла для сохранения <input id="modal_save_name" value="logs" />
            </div>
            <footer class="w3-container" style="padding-bottom: 4px">
              <div style="float:right">
                <button type="button" class="w3-bar-item w3-button w3-red w3-round" onclick="document.getElementById('modal_save_log').style.display='none'">
                  Отмена
                </button>
                <button type="button" onclick="startDonwnloadLog()" class="w3-bar-item w3-button w3-teal w3-round">Сохранить</button> <br />
              </div>
            </footer>
          </div>
        </div>

        <!-- Модальное окно Сохранение событий -->
        <div id="modal_save_message" class="w3-modal">
          <div class="w3-modal-content w3-animate-top w3-card-4">
            <header class="w3-container w3-teal">
              <span onclick="document.getElementById('modal_save_message').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
              <h2>Сохранение логов из прибора</h2>
            </header>
            <div class="w3-container">
              <br />
              Название файла для сохранения <input id="modal_save_name_msg" value="События" />
            </div>
            <footer class="w3-container" style="padding-bottom: 4px">
              <div style="float:right">
                <button
                  type="button"
                  class="w3-bar-item w3-button w3-red w3-round"
                  onclick="document.getElementById('modal_save_message').style.display='none'"
                >
                  Отмена
                </button>
                <button type="button" onclick="startDonwnloadMsg()" class="w3-bar-item w3-button w3-teal w3-round">Сохранить</button> <br />
              </div>
            </footer>
          </div>
        </div>

        <!-- Модальное окно Очистки логов -->
        <div id="modal_clear_log" class="w3-modal">
          <div class="w3-modal-content w3-animate-top w3-card-4">
            <header class="w3-container w3-teal">
              <span onclick="document.getElementById('modal_save_log').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
              <h2>Очистка логов</h2>
            </header>
            <div class="w3-container">
              <br />
              Вы действительно хотите очистить логи в приборе ?
            </div>
            <footer class="w3-container" style="padding-bottom: 4px">
              <div style="float:right">
                <button type="button" class="w3-bar-item w3-button w3-red w3-round" onclick="document.getElementById('modal_clear_log').style.display='none'">
                  Отмена
                </button>
                <button type="button" onclick="startClearLogs()" class="w3-bar-item w3-button w3-teal w3-round">Очистить</button> <br />
              </div>
            </footer>
          </div>
        </div>

        <!-- Модальное окно сброса настроек на заводские -->
        <div id="modal_default_conf" class="w3-modal">
          <div class="w3-modal-content w3-animate-top w3-card-4">
            <header class="w3-container w3-teal">
              <span onclick="document.getElementById('modal_default_conf').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
              <h2>Сброс настроек прибора</h2>
            </header>
            <div class="w3-container">
              <br />
              Вы действительно хотите сбросить настройки прибора на заводские ?
            </div>
            <footer class="w3-container" style="padding-bottom: 4px">
              <div style="float:right">
                <button
                  type="button"
                  class="w3-bar-item w3-button w3-red w3-round"
                  onclick="document.getElementById('modal_default_conf').style.display='none'"
                >
                  Отмена
                </button>
                <button type="button" onclick="configToDefault()" class="w3-bar-item w3-button w3-teal w3-round">Сбросить</button> <br />
              </div>
            </footer>
          </div>
        </div>

        <!-- Модальное окно очистки логов -->
        <div id="modal_device_mod" class="w3-modal">
          <div class="w3-modal-content w3-animate-top w3-card-4">
            <header class="w3-container w3-teal">
              <span onclick="document.getElementById('modal_device_mod').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
              <h2>Очистка логов</h2>
            </header>
            <div class="w3-container">
              <br />
              Вы действительно хотите очистить логи в приборе ?
            </div>
            <footer class="w3-container" style="padding-bottom: 4px">
              <div style="float:right">
                <button type="button" class="w3-bar-item w3-button w3-red w3-round" onclick="document.getElementById('modal_device_mod').style.display='none'">
                  Отмена
                </button>
                <button type="button" onclick="console.log('что то делаем')" class="w3-bar-item w3-button w3-teal w3-round">Очистить</button> <br />
              </div>
            </footer>
          </div>
        </div>

        <!-- Модальное окно вИЗ ПРИБОРА -->
        <div id="modal_load_conf_device" class="w3-modal">
          <div class="w3-modal-content w3-animate-top w3-card-4">
            <header class="w3-container w3-teal">
              <span onclick="document.getElementById('modal_load_conf_device').style.display='none'" class="w3-button w3-display-topright">&#10006;</span>
              <h2>Очистка логов</h2>
            </header>
            <div class="w3-container">
              <br />
              Загрузить конфигурацию из прибора ?
            </div>
            <footer class="w3-container" style="padding-bottom: 4px">
              <div style="float:right">
                <button
                  type="button"
                  class="w3-bar-item w3-button w3-red w3-round"
                  onclick="document.getElementById('modal_load_conf_device').style.display='none'"
                >
                  Отмена
                </button>
                <button type="button" onclick="console.log('что то делаем')" class="w3-bar-item w3-button w3-teal w3-round">Да</button> <br />
              </div>
            </footer>
          </div>
        </div>

        <!-- Модальное окно загрузки конфигурации -->
        <div id="modal_progres" class="w3-modal">
          <div class="w3-modal-content w3-animate-top w3-card-4">
            <header class="w3-container w3-teal"><span id="modal_progres_text_cancel" class="w3-display-topright" style="color:#000; left: 36%"></span></header>
            <div class="w3-light-grey">
              <div id="continBar" class="w3-container w3-blue" style="width:0%"><span id="continBarProc">0%</span></div>
            </div>
          </div>
          <footer class="w3-container" style="padding-bottom: 4px"></footer>
        </div>
        <div style='display:none' onclick="scrollUpPage()" id="arrowTop"></div>
        <div style='display:none' onclick="scrollDownPage()" id="arrowDown"></div>
        
        <!-- Модальное окно загрузки всех приборов -->
        <div id="modal_progres_mix" class="w3-mix">
          <div class="w3-modal-content w3-animate-top w3-card-4">
            <header class="w3-container w3-teal"><span id="modal_progres_text_mix" class="w3-display-topright" style="color:#000; left: 36%"></span></header>
            <div class="w3-light-grey">
              <div id="continBar" class="w3-container w3-blue" style="width:0%"><span id="continBarProc">0%</span></div>
            </div>
          </div>
          <footer class="w3-container" style="padding-bottom: 4px"></footer>
        </div>
       
     

      <!-- Модальное окно обаружения датчиков -->
      <div id="modal_progres_detected" class="w3-modal">
        <div class="w3-modal-content w3-animate-top w3-card-4">
          <header class="w3-container w3-teal"><span id="modal_progres_detected_text_cancel" class="w3-display-topright" style="color:#000; left: 36%"></span></header>
          <div class="w3-light-grey">
            <div id="continBarDetected" class="w3-container w3-blue" style="width:0%"><span id="continBarProcDetected">0%</span></div>
          </div>
        </div>
        <footer class="w3-container" style="padding-bottom: 4px"></footer>
      </div>
    </div>

    <!-- Модальное окно ошибки повторной привязки датчиков -->
    <div id="modal_error_radio_detected" class="w3-modal">
      <form>
        <div class="w3-modal-content w3-animate-top w3-card-4">
          <header class="w3-container w3-red">
            <span onclick="stopSearchRadio()" class="w3-button w3-display-topright">&#10006;</span>
            <h2>Ошибка</h2>
          </header>
          <div class="w3-container">                
          <br />
          Устройство уже имеет адрес с номером - <span id="repeat_radio"><span/>
            
          </div>
          <footer class="w3-container" style="padding-bottom: 4px">
            <div style="float:right">
            
              <button
                type="button"
                class="w3-bar-item w3-button w3-red w3-round"
                onclick="stopSearchRadio()"
              >
                ок
              </button>
              
            </div>
          </footer>
        </div>
      </form>
    </div>

      <div class="w3-bottom" style="background: #3d3d3d; color:#fff">
        <div style="float:left; margin: 5px 0 5px 10px">2023 © <a href="http://elesta.ru" target="_blank">Элеста</a></div>
        <div title="Информация о конфигураторе" style="float:right; margin: 5px 10px 5px 0">Web-приложение "Конфигуратор приборов" версия <span id="versionIndex"></span></div>
      </div>
      <div style="display:none" id="print-content">Содержимое для печати</div>
  `;
  document.getElementById("tunerDevice").innerHTML = str;
}
