/*!
 * Pereplet JavaScript Library v0.1
 * Author Procenko Konstantin
 !*/

function superFetch(query) {
    var xhr = new XMLHttpRequest();
    xhr.open("GET", vhost + query, true);
    xhr.send();
    if (xhr.status != 200) {
        return "error";
    } else {
        return JSON.parse(xhr.responseText); // ответ
    }
}

function superFetchPost(query, body) {
    var xhr = new XMLHttpRequest();

    xhr.open("POST", vhost + query, true);
    xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    //xhr.setRequestHeader("Content-Type", "application/json");

    xhr.onreadystatechange = function () {
        if (this.readyState != 4) return;
        alert(this.responseText);
    };

    xhr.send(body);
}

var $ = new Pereplet();

function Pereplet(data) {
    this.hide = function (classId) {
        let typeElement = classId.charAt(0);
        let el = classId.substr(1);
        if (typeElement == ".") {
            element = document.getElementsByClassName(el);
            for (var i = 0; i < element.length; i++) element[i].style.display = "none";
        } else if (typeElement == "#") {
            document.getElementById(el) ? document.getElementById(el).style.display = "none" : "";
        }
    };

    this.show = function (classId) {
        let typeElement = classId.charAt(0);
        let el = classId.substr(1);
        if (typeElement == ".") {
            element = document.getElementsByClassName(el);
            for (var i = 0; i < element.length; i++) element[i].style.display = "";
        } else if (typeElement == "#") {
            document.getElementById(el) ? document.getElementById(el).style.display = "" : "";
        }
    };

    this.modal = function (classId) {
        let typeElement = classId.charAt(0);
        let el = classId.substr(1);
        if (typeElement == ".") {
            element = document.getElementsByClassName(el);
            for (var i = 0; i < element.length; i++) element[i].style.display = "block";
        } else if (typeElement == "#") {
            document.getElementById(el) ? document.getElementById(el).style.display = "block" : "";
        }
    };

    this.removeClass = function (classId, whoRemove) {
        //this.removeClass = function(classId, whoRemove = null) { ЗАКОМЕНТИРОВАННАЯ СТРОЧКА ВЫШЕ ДО ОПТИМИЗАЦИИ ДЛЯ ИЕ
        if (whoRemove == "undefined") {
            whoRemove = null;
        }
        let typeElement = classId.charAt(0);
        let el = classId.substr(1);
        if (typeElement == ".") {
            element = document.getElementsByClassName(el);
            for (var i = 0; i < element.length; i++) element[i].className = element[0].className.replace(whoRemove, "");
        } else if (typeElement == "#") {
            document.getElementById(el) ? document.getElementById(el).classList.remove(whoRemove) : "";
        }
    };


    this.styleRkpsZone = function(id, status){
        console.log(id, status);
    }
}

function containsArray(where, what) {
    // вхождение одного массива в друой
    for (var i = 0; i < what.length; i++) {
        if (where.indexOf(what[i]) == -1) return false;
    }
    return true;
}

function create_yz() {
    let str = "";
    let key = "";
    for (var i = 1; i <= 32; i++) {
        str += '{key:"XXDR' + i + '",';
        str += "subvalues: [";
        str += '{ value:"", index: 1},{ value:"", index: 2}]},';
    }    
}

function compare(a, b) {
    const genreA = a.key.toUpperCase();
    const genreB = b.key.toUpperCase();

    let comparison = 0;
    if (genreA > genreB) {
        comparison = 1;
    } else if (genreA < genreB) {
        comparison = -1;
    }
    return comparison;
}

function thisindexDetails(elm) {
    var nodes = elm.parentNode.childNodes,
        node;
    var i = 0,
        count = i;
    while ((node = nodes.item(i++)) && node != elm)
        if (node.nodeType == 1) count++;
    return count;
}

function closeAllDetails(index) {
    var len = document.getElementsByTagName("details").length;

    for (var i = 0; i < len; i++) {
        if (i != index) {
            //document.getElementsByTagName("details")[i].removeAttribute("open");
        }
    }
}

function setOnlyNumber(data) {
    if (data.value.match(/[^0-9]/g)) {
        data.value = data.value.slice(0, -1);
        return;
    }
}

function errorCore(key) {    
    //console.log('Не найден конфигурационный ключ - ' + key);
    return ''
}