


let DEVICEINFO = {
  S2413: {
    model: "Сатурн-2413",
    idBoard: null,
    sections: 4,
    sensor: 8,
    ok: 2,
    defaultClick: "defaultClick",
    secondclick: "secondclick",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "startTuner",
      "tab_statusDevice",
      "tab_main",
      "tab_sensors",
      "tab_ok",
      "tab_gsm",
      "tab_keys",
      "tab_events",
      "tab_logs",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls()",
      GS: "searchKey_GS4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "searchKey_LM_LR()", // Шлейфы
      RL: "$.hide('#telemetria_4')", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "searchKey_OC()", // Открытые Колекторы
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "searchKey_SN_1_2()", // Номер телефона сим от 1 до 6
    },
  },
  S2813: {
    model: "Сатурн-2813",
    idBoard: null,
    sections: 16,
    sensor: 8,
    ok: 10,
    defaultClick: "defaultClick",
    secondclick: "secondclick",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "startTuner",
      "tab_statusDevice",
      "tab_extender",
      "tab_main",
      "tab_sensors",
      "tab_ok",
      "tab_gsm",
      "tab_keys",
      "tab_events",
      "tab_logs",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls()",
      GS: "searchKey_GS4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "searchKey_LM_LR()", // Шлейфы
      RL: "searchKey_RL_281x()", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "searchKey_OC()", // Открытые Колекторы
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "searchKey_SN_1_2()", // Номер телефона сим от 1 до 6
    },
  },
  S2814: {
    model: "Сатурн-2814",
    idBoard: null,
    sections: 16,
    sensor: 8,
    ok: 10,
    defaultClick: "defaultClick",
    secondclick: "secondclick",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "startTuner",
      "tab_statusDevice",
      "tab_extender",
      "tab_main",
      "tab_sensors",
      "tab_ok",
      "tab_gsm",
      "tab_keys",
      "tab_events",
      "tab_logs",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls()",
      GS: "searchKey_GS4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "searchKey_LM_LR()", // Шлейфы
      RL: "searchKey_RL_281x()", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "searchKey_OC()", // Открытые Колекторы
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "searchKey_SN_1_2()", // Номер телефона сим от 1 до 6
    },
  },
  S2818: {
    model: "Сатурн-2818",
    idBoard: null,
    sections: 16,
    sensor: 8,
    ok: 10,
    defaultClick: "defaultClick",
    secondclick: "secondclick",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "startTuner",
      "tab_statusDevice",
      "tab_extender",
      "tab_main",
      "tab_sensors",
      "tab_ok",
      "tab_gsm",
      "tab_keys",
      "tab_events",
      "tab_logs",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls()",
      GS: "searchKey_GS4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "searchKey_LM_LR()", // Шлейфы
      RL: "searchKey_RL_281x()", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "searchKey_OC()", // Открытые Колекторы
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "searchKey_SN_1_2()", // Номер телефона сим от 1 до 6
    },
  },
  S2819: {
    model: "Сатурн-2819",
    idBoard: null,
    sections: 32,
    sensor: 8,
    ok: 12,
    defaultClick: "defaultClick",
    secondclick: "secondclick",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "startTuner",
      "tab_statusDevice",
      "tab_extender",
      "tab_main",
      "tab_sensors",
      "tab_ok",
      "tab_gsm",
      "tab_keys",
      "tab_events",
      "tab_logs",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls()",
      GS: "searchKey_GS4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "searchKey_LM_LR()", // Шлейфы
      RL: "searchKey_RL_281x()", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "searchKey_OC()", // Открытые Колекторы
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "searchKey_SN_1_2()", // Номер телефона сим от 1 до 6
    },
  },
  S2082: {
    model: "Сатурн-2082",
    idBoard: null,
    sections: 32,
    radio: 64,
    sensor: 1,
    ok: 17,
    defaultClick: "defaultClick",
    secondclick: "secondclick",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "startTuner",
      "tab_statusDevice",
      "tab_main",
      "tab_gsm",
      "tab_sms",
      "tab_keys",
      "tab_events",
      "tab_logs",
      "tab_exe",
      "tab_ethernet",
      "tab_updateSoft",
      "tab_extender",
      "tab_sections",
      "tab_r_device",
    ],
    module: {
      START: "createDefaultControls()",
      GS: "searchKey_GS6()", //IP -	UDP-порт для симкарт
      LM_LR: "", // Шлейфы
      INITDATA: "createVirtualTable()",
      RL: "render_searchKey_EXT_RADIODEV()", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "searchKey_OC()",
      OO: "searchKey_OO()", // Исполнительные устройства
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN: "searchKey_SN()", // SMS
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      XXAD: "render_VIRTUAL_XXAD()", // Радиоканальные устройства
      XXCC: "searchKey_XXCC()", // Настройка частот трансивера
      //ZONE: "render_VIRTUAL_ZONE()", // РАсстановка зон по разделам
      SECTIONS: "RENDER_VirtualSection()", // Создание разделов
    },
  },
  J2083: {
    model: "Юпитер-2083",
    idBoard: null,
    sections: 32,
    radio: 64,
    sensor: 1,
    ok: 17,
    defaultClick: "defaultClick",
    secondclick: "secondclick",
    gprs: true,
    ethernet: false,
    wifi: true,
    tabs: [
      "startTuner",
      "tab_statusDevice",
      "tab_main",
      "tab_gsm",
      "tab_sms",
      "tab_keys",
      "tab_events",
      "tab_logs",
      "tab_ethernet",
      "tab_updateSoft",
      "tab_extender",
      "tab_sections",
      "tab_exe",
      "tab_r_device",
    ],
    module: {
      START: "createDefaultControls()",
      GS: "searchKey_GS6()", //IP -	UDP-порт для симкарт
      LM_LR: "", // Шлейфы
      INITDATA: "createVirtualTable()",
      RL: "render_searchKey_EXT_RADIODEV()", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "searchKey_OC()",
      OO: "searchKey_OO()", // Исполнительные устройства
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      XXAD: "render_VIRTUAL_XXAD()", // Радиоканальные устройства
      XXCC: "searchKey_XXCC()", // Настройка частот трансивера
      //ZONE: "render_VIRTUAL_ZONE()", // РАсстановка зон по разделам
      SECTIONS: "RENDER_VirtualSection()", // Создание разделов
    },
  },
  J2083: {
    model: "Юпитер-2083",
    idBoard: null,
    sections: 32,
    radio: 64,
    sensor: 1,
    ok: 17,
    defaultClick: "defaultClick",
    secondclick: "secondclick",
    gprs: true,
    ethernet: false,
    wifi: true,
    tabs: [
      "startTuner",
      "tab_statusDevice",
      "tab_main",
      "tab_gsm",
      "tab_sms",
      "tab_keys",
      "tab_events",
      "tab_logs",
      "tab_ethernet",
      "tab_updateSoft",
      "tab_extender",
      "tab_sections",
      "tab_exe",
      "tab_r_device",
    ],
    module: {
      START: "createDefaultControls()",
      GS: "searchKey_GS6()", //IP -	UDP-порт для симкарт
      LM_LR: "", // Шлейфы
      INITDATA: "createVirtualTable()",
      RL: "render_searchKey_EXT_RADIODEV()", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "searchKey_OC()",
      OO: "searchKey_OO()", // Исполнительные устройства
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      XXAD: "render_VIRTUAL_XXAD()", // Радиоканальные устройства
      XXCC: "searchKey_XXCC()", // Настройка частот трансивера
      //ZONE: "render_VIRTUAL_ZONE()", // РАсстановка зон по разделам
      SECTIONS: "RENDER_VirtualSection()", // Создание разделов
    },
  },



  J2021N: {
    model: "Юпитер-2021",
    idBoard: null,
    sections: 32,
    radio: 64,
    sensor: 1,
    ok: 17,
    defaultClick: "defaultClick",
    secondclick: "secondclick",
    gprs: true,
    ethernet: false,
    wifi: true,
    tabs: [
      "startTuner",
      "tab_statusDevice",
      "tab_main",
      "tab_gsm",
      "tab_sms",
      "tab_keys",
      "tab_events",
      "tab_logs",
      "tab_ethernet",
      "tab_updateSoft",
      "tab_extender",
      "tab_sections",
      "tab_exe",
      "tab_r_device",
    ],
    module: {
      START: "createDefaultControls()",
      GS: "searchKey_GS6()", //IP -	UDP-порт для симкарт
      LM_LR: "", // Шлейфы
      INITDATA: "createVirtualTable()",
      RL: "render_searchKey_EXT_RADIODEV()", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "searchKey_OC()",
      OO: "searchKey_OO()", // Исполнительные устройства
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      XXAD: "render_VIRTUAL_XXAD()", // Радиоканальные устройства
      XXCC: "searchKey_XXCC()", // Настройка частот трансивера
      //ZONE: "render_VIRTUAL_ZONE()", // РАсстановка зон по разделам
      SECTIONS: "RENDER_VirtualSection()", // Создание разделов
    },
  },
  J2028N: {
    model: "Юпитер-2028",
    idBoard: null,
    sections: 32,
    radio: 64,
    sensor: 1,
    ok: 17,
    defaultClick: "defaultClick",
    secondclick: "secondclick",
    gprs: true,
    ethernet: false,
    wifi: true,
    tabs: [
      "startTuner",
      "tab_statusDevice",
      "tab_main",
      "tab_gsm",
      "tab_sms",
      "tab_keys",
      "tab_events",
      "tab_logs",
      "tab_ethernet",
      "tab_updateSoft",
      "tab_extender",
      "tab_sections",
      "tab_exe",
      "tab_r_device",
    ],
    module: {
      START: "createDefaultControls()",
      GS: "searchKey_GS6()", //IP -	UDP-порт для симкарт
      LM_LR: "", // Шлейфы
      INITDATA: "createVirtualTable()",
      RL: "render_searchKey_EXT_RADIODEV()", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "searchKey_OC()",
      OO: "searchKey_OO()", // Исполнительные устройства
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      XXAD: "render_VIRTUAL_XXAD()", // Радиоканальные устройства
      XXCC: "searchKey_XXCC()", // Настройка частот трансивера
      //ZONE: "render_VIRTUAL_ZONE()", // РАсстановка зон по разделам
      SECTIONS: "RENDER_VirtualSection()", // Создание разделов
    },
  },
  J2029N: {
    model: "Юпитер-2029",
    idBoard: null,
    sections: 32,
    radio: 64,
    sensor: 1,
    ok: 17,
    defaultClick: "defaultClick",
    secondclick: "secondclick",
    gprs: true,
    ethernet: false,
    wifi: true,
    tabs: [
      "startTuner",
      "tab_statusDevice",
      "tab_main",
      "tab_gsm",
      "tab_sms",
      "tab_keys",
      "tab_events",
      "tab_logs",
      "tab_ethernet",
      "tab_updateSoft",
      "tab_extender",
      "tab_sections",
      "tab_exe",
      "tab_r_device",
    ],
    module: {
      START: "createDefaultControls()",
      GS: "searchKey_GS6()", //IP -	UDP-порт для симкарт
      LM_LR: "", // Шлейфы
      INITDATA: "createVirtualTable()",
      RL: "render_searchKey_EXT_RADIODEV()", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "searchKey_OC()",
      OO: "searchKey_OO()", // Исполнительные устройства
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      XXAD: "render_VIRTUAL_XXAD()", // Радиоканальные устройства
      XXCC: "searchKey_XXCC()", // Настройка частот трансивера
      //ZONE: "render_VIRTUAL_ZONE()", // РАсстановка зон по разделам
      SECTIONS: "RENDER_VirtualSection()", // Создание разделов
    },
  },
  J2084: {
    model: "Юпитер-2084",
    idBoard: null,
    sections: 32,
    radio: 64,
    sensor: 1,
    ok: 17,
    defaultClick: "defaultClick",
    secondclick: "secondclick",
    gprs: true,
    ethernet: true,
    wifi: true,
    tabs: [
      "startTuner",
      "tab_statusDevice",
      "tab_main",
      "tab_gsm",
      "tab_sms",
      "tab_keys",
      "tab_events",
      "tab_logs",
      "tab_ethernet",
      "tab_updateSoft",
      "tab_exe",
      "tab_extender",
      "tab_sections",
      "tab_r_device",
    ],
    module: {
      START: "createDefaultControls()",
      GS: "searchKey_GS6()", //IP -	UDP-порт для симкарт
      LM_LR: "", // Шлейфы
      INITDATA: "createVirtualTable()",
      RL: "render_searchKey_EXT_RADIODEV()", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "searchKey_OC()", // Открытые Колекторы
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      OO: "searchKey_OO()", // Исполнительные устройства
      XXAD: "render_VIRTUAL_XXAD()", // Радиоканальные устройства
      XXCC: "searchKey_XXCC()", // Настройка частот трансивера
      //ZONE: "render_VIRTUAL_ZONE()", // РАсстановка зон по разделам
      SECTIONS: "RENDER_VirtualSection()", // Создание разделов
    },
  },
  J2084_v5: {
    model: "Юпитер-2084 v5",
    idBoard: null,
    sections: 32,
    radio: 64,
    sensor: 1,
    ok: 17,
    defaultClick: "defaultClick",
    secondclick: "secondclick",
    gprs: true,
    ethernet: true,
    wifi: true,
    tabs: [
      "startTuner",
      "tab_statusDevice",
      "tab_main",
      "tab_gsm",
      "tab_sms",
      "tab_keys",
      "tab_events",
      "tab_logs",
      "tab_ethernet",
      "tab_updateSoft",
      "tab_exe",
      "tab_extender",
      "tab_sections",
      "tab_r_device",
    ],
    module: {
      START: "createDefaultControls()",
      GS: "searchKey_GS6()", //IP -	UDP-порт для симкарт
      LM_LR: "", // Шлейфы
      INITDATA: "createVirtualTable()",
      RL: "render_searchKey_EXT_RADIODEV()", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "searchKey_OC()", // Открытые Колекторы
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      OO: "searchKey_OO()", // Исполнительные устройства
      XXAD: "render_VIRTUAL_XXAD()", // Радиоканальные устройства
      XXCC: "searchKey_XXCC()", // Настройка частот трансивера
      //ZONE: "render_VIRTUAL_ZONE()", // РАсстановка зон по разделам
      SECTIONS: "RENDER_VirtualSection()", // Создание разделов
    },
  },
  J2021: {
    model: "Юпитер-2021(2018г.)",
    idBoard: null,
    sections: 32,
    radio: 64,
    sensor: 1,
    ok: 17,
    defaultClick: "defaultClick",
    secondclick: "secondclick",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "startTuner",
      "tab_statusDevice",
      "tab_main",
      "tab_gsm",
      "tab_sms",
      "tab_keys",
      "tab_events",
      "tab_logs",
      "tab_updateSoft",
      "tab_sections",
      "tab_r_device",
    ],
    module: {
      START: "createDefaultControls()",
      GS: "searchKey_GS6()", //IP -	UDP-порт для симкарт
      LM_LR: "", // Шлейфы
      INITDATA: "createVirtualTable()",
      RL: "", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "", // Открытые Колекторы
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      XXAD: "render_VIRTUAL_XXAD()", // Радиоканальные устройства
      XXCC: "searchKey_XXCC()", // Настройка частот трансивера
      //ZONE: "render_VIRTUAL_ZONE()", // РАсстановка зон по разделам
      SECTIONS: "RENDER_VirtualSection()", // Создание разделов
    },
  },
  J2028: {
    model: "Юпитер-2028(2018г.)",
    idBoard: null,
    sections: 32,
    radio: 64,
    sensor: 1,
    ok: 17,
    defaultClick: "defaultClick",
    secondclick: "secondclick",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "startTuner",
      "tab_statusDevice",
      "tab_main",
      "tab_gsm",
      "tab_sms",
      "tab_keys",
      "tab_events",
      "tab_logs",
      "tab_updateSoft",
      "tab_sections",
      "tab_r_device",
    ],
    module: {
      START: "createDefaultControls()",
      GS: "searchKey_GS6()", //IP -	UDP-порт для симкарт
      LM_LR: "", // Шлейфы
      INITDATA: "createVirtualTable()",
      RL: "", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "", // Открытые Колекторы
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      XXAD: "render_VIRTUAL_XXAD()", // Радиоканальные устройства
      XXCC: "searchKey_XXCC()", // Настройка частот трансивера
      //ZONE: "render_VIRTUAL_ZONE()", // РАсстановка зон по разделам
      SECTIONS: "RENDER_VirtualSection()", // Создание разделов
    },
  },
  J2029: {
    model: "Юпитер-2029(2018г.)",
    idBoard: null,
    sections: 32,
    radio: 64,
    sensor: 1,
    ok: 17,
    defaultClick: "defaultClick",
    secondclick: "secondclick",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "startTuner",
      "tab_statusDevice",
      "tab_main",
      "tab_gsm",
      "tab_sms",
      "tab_keys",
      "tab_events",
      "tab_logs",
      "tab_updateSoft",
      "tab_sections",
      "tab_r_device",
    ],
    module: {
      START: "createDefaultControls()",
      GS: "searchKey_GS6()", //IP -	UDP-порт для симкарт
      LM_LR: "", // Шлейфы
      INITDATA: "createVirtualTable()",
      RL: "", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "", // Открытые Колекторы
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      XXAD: "render_VIRTUAL_XXAD()", // Радиоканальные устройства
      XXCC: "searchKey_XXCC()", // Настройка частот трансивера
      //ZONE: "render_VIRTUAL_ZONE()", // РАсстановка зон по разделам
      SECTIONS: "RENDER_VirtualSection()", // Создание разделов
    },
  },
  J2081: {
    model: "Юпитер-2081",
    idBoard: null,
    sections: 32,
    radio: 64,
    sensor: 1,
    ok: 17,
    defaultClick: "defaultClick",
    secondclick: "secondclick",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "startTuner",
      "tab_statusDevice",
      "tab_main",
      "tab_gsm",
      "tab_sms",
      "tab_keys",
      "tab_events",
      "tab_logs",
      "tab_updateSoft",
      "tab_exe",
      "tab_extender",
      "tab_sections",
      "tab_r_device",
    ],
    module: {
      START: "createDefaultControls()",
      GS: "searchKey_GS6()", //IP -	UDP-порт для симкарт
      LM_LR: "", // Шлейфы
      INITDATA: "createVirtualTable()",
      RL: "render_searchKey_EXT_RADIODEV()", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "searchKey_OC()",
      OO: "searchKey_OO()", // Исполнительные устройства
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      XXAD: "render_VIRTUAL_XXAD()", // Радиоканальные устройства
      XXCC: "searchKey_XXCC()", // Настройка частот трансивера
      //ZONE: "render_VIRTUAL_ZONE()", // РАсстановка зон по разделам
      SECTIONS: "RENDER_VirtualSection()", // Создание разделов
    },
  },
  J2082: {
    model: "Юпитер-2082",
    idBoard: null,
    sections: 32,
    radio: 64,
    sensor: 1,
    ok: 17,
    defaultClick: "defaultClick",
    secondclick: "secondclick",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "startTuner",
      "tab_statusDevice",
      "tab_main",
      "tab_gsm",
      "tab_sms",
      "tab_keys",
      "tab_events",
      "tab_logs",
      "tab_ethernet",
      "tab_updateSoft",
      "tab_extender",
      "tab_exe",
      "tab_sections",
      "tab_r_device",
    ],
    module: {
      START: "createDefaultControls()",
      GS: "searchKey_GS6()", //IP -	UDP-порт для симкарт
      LM_LR: "", // Шлейфы
      INITDATA: "createVirtualTable()",
      RL: "render_searchKey_EXT_RADIODEV()", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "",
      OO: "searchKey_OO()", // Исполнительные устройства
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      XXAD: "render_VIRTUAL_XXAD()", // Радиоканальные устройства
      XXCC: "searchKey_XXCC()", // Настройка частот трансивера
      //ZONE: "render_VIRTUAL_ZONE()", // РАсстановка зон по разделам
      SECTIONS: "RENDER_VirtualSection()", // Создание разделов
    },
  },
  J2082_v5: {
    model: "Юпитер-2082 v5",
    idBoard: null,
    sections: 32,
    radio: 64,
    sensor: 1,
    ok: 17,
    defaultClick: "defaultClick",
    secondclick: "secondclick",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "startTuner",
      "tab_statusDevice",
      "tab_main",
      "tab_gsm",
      "tab_sms",
      "tab_keys",
      "tab_events",
      "tab_logs",
      "tab_ethernet",
      "tab_updateSoft",
      "tab_extender",
      "tab_exe",
      "tab_sections",
      "tab_r_device",
    ],
    module: {
      START: "createDefaultControls()",
      GS: "searchKey_GS6()", //IP -	UDP-порт для симкарт
      LM_LR: "", // Шлейфы
      INITDATA: "createVirtualTable()",
      RL: "render_searchKey_EXT_RADIODEV()", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "",
      OO: "searchKey_OO()", // Исполнительные устройства
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      XXAD: "render_VIRTUAL_XXAD()", // Радиоканальные устройства
      XXCC: "searchKey_XXCC()", // Настройка частот трансивера
      //ZONE: "render_VIRTUAL_ZONE()", // РАсстановка зон по разделам
      SECTIONS: "RENDER_VirtualSection()", // Создание разделов
    },
  },
  S2081: {
    model: "Сатурн-2081",
    idBoard: null,
    sections: 32,
    radio: 64,
    sensor: 1,
    ok: 17,
    defaultClick: "defaultClick",
    secondclick: "secondclick",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "startTuner",
      "tab_statusDevice",
      "tab_main",
      "tab_gsm",
      "tab_sms",
      "tab_keys",
      "tab_events",
      "tab_logs",
      "tab_updateSoft",
      "tab_exe",
      "tab_sections",
      "tab_r_device",
    ],
    module: {
      START: "createDefaultControls()",
      GS: "searchKey_GS6()", //IP -	UDP-порт для симкарт
      LM_LR: "", // Шлейфы
      INITDATA: "createVirtualTable()",
      RL: "render_searchKey_EXT_RADIODEV()", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "searchKey_OC()",
      OO: "searchKey_OO()", // Исполнительные устройства
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      XXAD: "render_VIRTUAL_XXAD()", // Радиоканальные устройства
      XXCC: "searchKey_XXCC()", // Настройка частот трансивера
      //ZONE: "render_VIRTUAL_ZONE()", // РАсстановка зон по разделам
      SECTIONS: "RENDER_VirtualSection()", // Создание разделов
    },
  },
  S2082: {
    model: "Сатурн-2082",
    idBoard: null,
    sections: 32,
    radio: 64,
    sensor: 1,
    ok: 17,
    defaultClick: "defaultClick",
    secondclick: "secondclick",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "startTuner",
      "tab_statusDevice",
      "tab_main",
      "tab_gsm",
      "tab_sms",
      "tab_keys",
      "tab_events",
      "tab_logs",
      "tab_ethernet",
      "tab_updateSoft",
      "tab_extender",
      "tab_exe",
      "tab_sections",
      "tab_r_device",
    ],
    module: {
      START: "createDefaultControls()",
      GS: "searchKey_GS6()", //IP -	UDP-порт для симкарт
      LM_LR: "", // Шлейфы
      INITDATA: "createVirtualTable()",
      RL: "render_searchKey_EXT_RADIODEV()", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "",
      OO: "searchKey_OO()", // Исполнительные устройства
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      XXAD: "render_VIRTUAL_XXAD()", // Радиоканальные устройства
      XXCC: "searchKey_XXCC()", // Настройка частот трансивера
      //ZONE: "render_VIRTUAL_ZONE()", // РАсстановка зон по разделам
      SECTIONS: "RENDER_VirtualSection()", // Создание разделов
    },
  },
  S2084: {
    model: "Сатурн-2084",
    idBoard: null,
    sections: 32,
    radio: 64,
    sensor: 1,
    ok: 17,
    defaultClick: "defaultClick",
    secondclick: "secondclick",
    gprs: true,
    ethernet: true,
    wifi: true,
    tabs: [
      "startTuner",
      "tab_statusDevice",
      "tab_main",
      "tab_gsm",
      "tab_sms",
      "tab_keys",
      "tab_events",
      "tab_logs",
      "tab_ethernet",
      "tab_updateSoft",
      "tab_exe",
      "tab_extender",
      "tab_sections",
      "tab_r_device",
    ],
    module: {
      START: "createDefaultControls()",
      GS: "searchKey_GS6()", //IP -	UDP-порт для симкарт
      LM_LR: "", // Шлейфы
      INITDATA: "createVirtualTable()",
      RL: "render_searchKey_EXT_RADIODEV()", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "searchKey_OC()", // Открытые Колекторы
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      OO: "searchKey_OO()", // Исполнительные устройства
      XXAD: "render_VIRTUAL_XXAD()", // Радиоканальные устройства
      XXCC: "searchKey_XXCC()", // Настройка частот трансивера
      //ZONE: "render_VIRTUAL_ZONE()", // РАсстановка зон по разделам
      SECTIONS: "RENDER_VirtualSection()", // Создание разделов
    },
  },
  J2443: {
    model: "Юпитер-2443",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2443_GD: {
    model: "Юпитер-2443",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2413: {
    model: "Юпитер-2413",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",

      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2413_GD: {
    model: "Юпитер-2413",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",

      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2444: {
    model: "Юпитер-2444",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_plugin_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2444_GD: {
    model: "Юпитер-2444",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_plugin_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2444E: {
    model: "Юпитер-2444РШ",
    idBoard: null,
    sections: 16,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_plugin_pk4",
      "tab_hw1",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "searchKey_LM_LR_pk4()", // Шлейфы
      RL: "searchKey_RL_pk4()", // Расширители
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2445E: {
    model: "Юпитер-2445РШ",
    idBoard: null,
    sections: 16,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_plugin_pk4",
      "tab_hw1",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      RL: "pk4_search_exe()", // Расширители ДОЛЖНЫ БЫТЬ РАНЬШЕ РЕНДЕРА ЗОН!!!!
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "searchKey_LM_LR_pk4()", // Шлейфы
      RL: "searchKey_RL_pk4()", // Расширители
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2444_2022: {
    model: "Юпитер-2444(2022)",
    idBoard: null,
    sections: 16,
    sensor: 4,
    ok: 19,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_plugin_pk4",
      "tab_hw1",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "searchKey_LM_LR_pk4()", // Шлейфы
      RL: "searchKey_RL_pk4()", // Расширители
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "searchKey_OCv2()", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2445_2022: {
    model: "Юпитер-2445(2022)",
    idBoard: null,
    sections: 16,
    sensor: 4,
    ok: 19,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_plugin_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      RL: "pk4_search_exe()", // Расширители ДОЛЖНЫ БЫТЬ РАНЬШЕ РЕНДЕРА ЗОН!!!!
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      // RL: "", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "searchKey_OCv2()", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2413_2022: {
    model: "Юпитер-2413(2022)",
    idBoard: null,
    sections: 16,
    sensor: 4,
    ok: 19,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",

      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "searchKey_OCv2()", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2443_2022: {
    model: "Юпитер-2443(2022)",
    idBoard: null,
    sections: 16,
    sensor: 4,
    ok: 19,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",

      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "searchKey_OCv2()", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2463_2022: {
    model: "Юпитер-2463(2022)",
    idBoard: null,
    sections: 16,
    sensor: 4,
    ok: 19,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: true,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_plugin_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "searchKey_LM_LR_pk4()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "searchKey_RL_pk4()", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "searchKey_OCv2()", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2463: {
    model: "Юпитер-2463",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: true,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_plugin_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2463_GD: {
    model: "Юпитер-2463",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: true,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_plugin_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2463E: {
    model: "Юпитер-2463РШ",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: true,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_plugin_pk4",
      "tab_hw1",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "searchKey_LM_LR_pk4()", // Шлейфы
      RL: "searchKey_RL_pk4()", // Расширители
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2445: {
    model: "Юпитер-2445",
    idBoard: null,
    sections: 16,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_plugin_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      RL: "pk4_search_exe()", // Расширители ДОЛЖНЫ БЫТЬ РАНЬШЕ РЕНДЕРА ЗОН!!!!
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      // RL: "", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2445_GD: {
    model: "Юпитер-2445",
    idBoard: null,
    sections: 16,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_plugin_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      RL: "pk4_search_exe()", // Расширители ДОЛЖНЫ БЫТЬ РАНЬШЕ РЕНДЕРА ЗОН!!!!
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      // RL: "", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2403: {
    model: "Юпитер-2403",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: false,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_ip_udp_pk4",
      "tab_mode_pk4",
      "tab_ethernet",
      "tab_plugin_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J1429: {
    model: "Юпитер-1429",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J1429v3: {
    model: "Юпитер-1429",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J1431: {
    model: "Юпитер-1431",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J1431_GD: {
    model: "Юпитер-1431(GD)",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J1439: {
    model: "Юпитер-1439",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J1433: {
    model: "Юпитер-1433",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J1433_GD: {
    model: "Юпитер-1433(GD)",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J1831: {
    model: "Юпитер-1831",
    idBoard: null,
    sections: 8,
    sensor: 8,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J1831_GD: {
    model: "Юпитер-1831(GD)",
    idBoard: null,
    sections: 8,
    sensor: 8,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J1833: {
    model: "Юпитер-1833",
    idBoard: null,
    sections: 8,
    sensor: 8,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J1833_GD: {
    model: "Юпитер-1833(GD)",
    idBoard: null,
    sections: 8,
    sensor: 8,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J1839: {
    model: "Юпитер-1839",
    idBoard: null,
    sections: 8,
    sensor: 8,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J1931: {
    model: "Юпитер-1931",
    idBoard: null,
    sections: 16,
    sensor: 16,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J1931_GD: {
    model: "Юпитер-1931(GD)",
    idBoard: null,
    sections: 16,
    sensor: 16,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J1933: {
    model: "Юпитер-1933",
    idBoard: null,
    sections: 16,
    sensor: 16,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ethernet",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J1933_GD: {
    model: "Юпитер-1933(GD)",
    idBoard: null,
    sections: 16,
    sensor: 16,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ethernet",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J1939: {
    model: "Юпитер-1939",
    idBoard: null,
    sections: 16,
    sensor: 16,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ethernet",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J1443: {
    model: "Юпитер-1443",
    idBoard: null,
    sections: 16,
    sensor: 16,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ethernet",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J1843: {
    model: "Юпитер-1843",
    idBoard: null,
    sections: 16,
    sensor: 16,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_plugin_pk4",
      "tab_ethernet",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "searchKey_LM_LR_pk4()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "searchKey_RL_pk4()", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J1943: {
    model: "Юпитер-1943",
    idBoard: null,
    sections: 16,
    sensor: 16,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_plugin_pk4",
      "tab_ethernet",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "searchKey_LM_LR_pk4()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "searchKey_RL_pk4()", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J1943_GD: {
    model: "Юпитер-1943(GD)",
    idBoard: null,
    sections: 16,
    sensor: 16,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_plugin_pk4",
      "tab_ethernet",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "searchKey_LM_LR_pk4()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "searchKey_RL_pk4()", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2420: {
    model: "Юпитер-2420",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_plugin_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN_KTS()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2420_2022: {
    model: "Юпитер-2420(2022)",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 2,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_plugin_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "searchKey_OCv2()", // Открытые Колекторы
      SN: "searchKey_SN_KTS()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2421: {
    model: "Юпитер-2421",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_plugin_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN_KTS()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2420_v2: {
    model: "Юпитер-2420 v2",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 2,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      /*  RELE: "pk4_render_rele()", // Расширители */
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "searchKey_OCv2()", // Открытые Колекторы
      SN: "searchKey_SN()", // SMS
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2421_v2: {
    model: "Юпитер-2421 v2",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 2,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      /*  RELE: "pk4_render_rele()", // Расширители */
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "searchKey_OCv2()", // Открытые Колекторы
      SN: "searchKey_SN()", // SMS
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2422: {
    model: "Юпитер-2422",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_plugin_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN_KTS()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2422_v2: {
    model: "Юпитер-2422 v2",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 2,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      /* RELE: "pk4_render_rele()", // Расширители */
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "searchKey_OCv2()", // Открытые Колекторы
      SN: "searchKey_SN()", // SMS
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2424: {
    model: "Юпитер-2424",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_plugin_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN_KTS()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },

  J2424_v2: {
    model: "Юпитер-2424 v2",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 2,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      /* RELE: "pk4_render_rele()", // Расширители */
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "searchKey_OCv2()", // Открытые Колекторы
      SN: "searchKey_SN()", // SMS
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2425: {
    model: "Юпитер-2425",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_plugin_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN_KTS()", // SMS
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },

  J2425_v2: {
    model: "Юпитер-2425 v2",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 2,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      /*  RELE: "pk4_render_rele()", // Расширители */
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "searchKey_OCv2()", // Открытые Колекторы
      SN: "searchKey_SN()", // SMS
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2426: {
    model: "Юпитер-2426",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_plugin_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN_KTS()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2426_v2: {
    model: "Юпитер-2426 v2",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 2,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: false,
    wifi: true,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      /*  RELE: "pk4_render_rele()", // Расширители */
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "searchKey_OCv2()", // Открытые Колекторы
      SN: "searchKey_SN()", // SMS
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2427: {
    model: "Юпитер-2427",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_plugin_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN_KTS()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2427_v2: {
    model: "Юпитер-2427 v2",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 2,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: true,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      /* RELE: "pk4_render_rele()", // Расширители */
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "searchKey_OCv2()", // Открытые Колекторы
      SN: "searchKey_SN_KTS()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2427_2022: {
    model: "Юпитер-2427(2022)",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 2,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: true,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_rele_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_ethernet",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      /* RELE: "pk4_render_rele()", // Расширители */
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "searchKey_XO()", // Задержки разделов
      OC: "searchKey_OCv2()", // Открытые Колекторы
      SN: "searchKey_SN_KTS()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2428: {
    model: "Юпитер-2428",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_plugin_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN_KTS()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2428_v2: {
    model: "Юпитер-2428 v2",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 2,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_plugin_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "searchKey_OCv2()", // Открытые Колекторы
      SN: "searchKey_SN_KTS()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2428_2022: {
    model: "Юпитер-2428(2022)",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 2,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_plugin_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "searchKey_OCv2()", // Открытые Колекторы
      SN: "searchKey_SN_KTS()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2429: {
    model: "Юпитер-2429",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_plugin_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN_KTS()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2429_v2: {
    model: "Юпитер-2429 v2",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 2,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_plugin_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "searchKey_OCv2()", // Открытые Колекторы
      SN: "searchKey_SN_KTS()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2429_2022: {
    model: "Юпитер-2429(2022)",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 2,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_plugin_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "pk4_render_rele()", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "searchKey_OCv2()", // Открытые Колекторы
      SN: "searchKey_SN_KTS()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2320: {
    model: "Юпитер-2320",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_plugin_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN_KTS()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2321: {
    model: "Юпитер-2321",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_plugin_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN_KTS()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J2326: {
    model: "Юпитер-2326",
    idBoard: null,
    sections: 4,
    sensor: 4,
    ok: 0,
    defaultClick: "defaultClick_pk4",
    secondclick: "secondclick_pk4",
    gprs: true,
    ethernet: true,
    wifi: false,
    tabs: [
      "tab_main_pk4",
      "tab_mode_pk4",
      "tab_indication_pk4",
      "tab_sensors_pk4",
      "tab_keys",
      "tab_sms",
      "tab_gsm_call_pk4",
      "tab_ip_udp_pk4",
      "tab_gprs_pk4",
      "tab_plugin_pk4",
      "tab_updateSoft",
    ],
    module: {
      START: "createDefaultControls_pk4()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GPRS_pk4()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "pk4_render_sensors()", // Шлейфы
      RELE: "", // Расширители
      GSM: "pk4_render_gsm()", // GSM дозвон
      UDP: "pk4_render_udpCode()", // GSM дозвон
      LAN: "", // Расширители
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      SN: "searchKey_SN_KTS()", // Коды пользователей
      SU: "searchKey_SU()", // Коды пользователей Взятие/Снятие
      UA_UZ: "searchKey_UA_UZ()", // Коды пользователей
      SN_1_2: "", // Номер телефона сим 1 и 2
    },
  },
  J6423: {
    model: "Юпитер-6423",
    idBoard: null,
    sections: 4,
    sensor: 8,
    ok: 2,
    defaultClick: "defaultClick",
    secondclick: "secondclick",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: ["startTuner", "tab_statusDevice", "tab_main", "tab_gsm", "tab_gsm_call_pk4", "tab_events", "tab_logs", "tab_updateSoft"],
    module: {
      START: "createDefaultControls()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GS6()", //формируем группу контролов для рендера listFixedSensors
      GSM: "pk4_render_gsm()", // GSM дозвон
      LM_LR: "", // Шлейфы
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      UA_UZ: "", // Коды пользователей
      SN_1_2: "searchKey_SN_1_2()", // Номер телефона сим 1 и 2
    },
  },
  J6422: {
    model: "Юпитер-6422",
    idBoard: null,
    sections: 4,
    sensor: 8,
    ok: 2,
    defaultClick: "defaultClick",
    secondclick: "secondclick",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: ["startTuner", "tab_statusDevice", "tab_main", "tab_gsm", "tab_events", "tab_gsm_call_pk4", "tab_logs", "tab_updateSoft"],
    module: {
      START: "createDefaultControls()",
      INITDATA: "pk4_init_key()",
      GS: "searchKey_GS6()", //формируем группу контролов для рендера listFixedSensors
      GSM: "pk4_render_gsm()", // GSM дозвон
      LM_LR: "", // Шлейфы
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      UA_UZ: "", // Коды пользователей
      SN_1_2: "searchKey_SN_1_2()", // Номер телефона сим 1 и 2
    },
  },
  J3431: {
    model: "Юпитер-3431",
    idBoard: null,
    sections: 4,
    sensor: 8,
    ok: 2,
    defaultClick: "defaultClick",
    secondclick: "secondclick",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: ["tab_updateSoft"],
    module: {
      START: "createDefaultControls()",
      GS: "searchKey_GS6()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "", // Шлейфы
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      UA_UZ: "", // Коды пользователей
      SN_1_2: "searchKey_SN_1_2()", // Номер телефона сим 1 и 2
    },
  },
  J3438: {
    model: "Юпитер-3438",
    idBoard: null,
    sections: 4,
    sensor: 8,
    ok: 2,
    defaultClick: "defaultClick",
    secondclick: "secondclick",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: ["tab_updateSoft"],
    module: {
      START: "createDefaultControls()",
      GS: "searchKey_GS6()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "", // Шлейфы
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      UA_UZ: "", // Коды пользователей
      SN_1_2: "searchKey_SN_1_2()", // Номер телефона сим 1 и 2
    },
  },
  J3439: {
    model: "Юпитер-3439",
    idBoard: null,
    sections: 4,
    sensor: 8,
    ok: 2,
    defaultClick: "defaultClick",
    secondclick: "secondclick",
    gprs: true,
    ethernet: false,
    wifi: false,
    tabs: ["tab_updateSoft"],
    module: {
      START: "createDefaultControls()",
      GS: "searchKey_GS6()", //формируем группу контролов для рендера listFixedSensors
      LM_LR: "", // Шлейфы
      RL: "", // Расширители
      XO: "", // Задержки разделов
      OC: "", // Открытые Колекторы
      UA_UZ: "", // Коды пользователей
      SN_1_2: "searchKey_SN_1_2()", // Номер телефона сим 1 и 2
    },
  },
};
